/* 
SUPPORT: sinprs Swain, Pradeep
*/ 
/****************************************************************************** 
 * Job:             Load_STG2DM_Geo_prod_vat                                  * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Tables:   STG_GEO_PROD_VAT -                                        * 
 *                   DIDM_STG.STG_GEO_PROD_VAT                                * 
 *                  GEOGRAPHY_DM - DI_DM.GEOGRAPHY_DM                         * 
 *                  PROD_HIER_SK - DI_MON.PROD_HIER_SK                        * 
 * Target Table:    GEO_PROD_VAT - DI_DM.GEO_PROD_VAT                         * 
 *                                                                            * 
 * Generated on:    Tuesday, November 3, 2009 2:36:11 PM GMT+05:30            * 
 ******************************************************************************/ 

/* General macro variables  */ 
%let jobID = %quote(A5W0V4GZ.BF0002LL);
%let etls_jobName = %nrquote(Load_STG2DM_Geo_prod_vat);

/* Setup to capture return codes  */ 
%global job_rc trans_rc sqlrc; 
%let sysrc = 0;
%let job_rc = 0;
%let trans_rc = 0;
%let sqlrc = 0;
%global syserr; 

%macro rcSet(error); 
   %if (&error gt &trans_rc) %then 
      %let trans_rc = &error;
   %if (&error gt &job_rc) %then 
      %let job_rc = &error;
%mend rcSet; 

%macro rcSetDS(error); 
   if &error gt input(symget('trans_rc'),12.) then 
      call symput('trans_rc',trim(left(put(&error,12.))));
   if &error gt input(symget('job_rc'),12.) then 
      call symput('job_rc',trim(left(put(&error,12.))));
%mend rcSetDS; 

/* Create metadata macro variables */
%let IOMServer      = %nrquote(MIMain);
%let metaPort       = %nrquote(8561);
%let metaServer     = %nrquote(puneasd10.apac.sas.com);

/* Set metadata options */
options metaport       = &metaPort 
        metaserver     = "&metaServer"; 

/* Setup for capturing job status  */ 
%let etls_startTime = %sysfunc(datetime(),datetime.);
%let etls_recordsBefore = 0;
%let etls_recordsAfter = 0;
%let etls_lib = 0;
%let etls_table = 0;

%global etls_debug; 
%macro etls_setDebug; 
   %if %str(&etls_debug) ne 0 %then 
      OPTIONS MPRINT%str(;); 
%mend; 
%etls_setDebug; 

/*---- Start of Pre-Process Code  ----*/ 

/**/
%etl_initjobparam (monlib=di_mon, jobname=%nrquote(&etls_jobName));
/**/
%etl_initchangeflags;
/*---- End of Pre-Process Code  ----*/ 

%rcSet(&syserr); 
%rcSet(&sqlrc); 

/*============================================================================* 
 * Step:            UW_Check_Existence                      A5W0V4GZ.BH000HRI * 
 * Transform:       User Written                                              * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Table:    STG_GEO_PROD_VAT -                      A5W0V4GZ.BB0007WV * 
 *                   DIDM_STG.STG_GEO_PROD_VAT                                * 
 * Target Table:    User Written -                          A5W0V4GZ.BK000EIU * 
 *                   DIDM_STG.STG_GEO_PROD_VAT                                * 
 *                                                                            * 
 * User Written:    SourceCode                                                * 
 *============================================================================*/ 

%let transformID = %quote(A5W0V4GZ.BH000HRI);
%let trans_rc = 0;
%let etls_stepStartTime = %sysfunc(datetime(), datetime20.); 

%let SYSLAST = %nrquote(DIDM_STG.STG_GEO_PROD_VAT); 

%let _INPUT_count = 1;
%let _INPUT = DIDM_STG.STG_GEO_PROD_VAT;
%let _INPUT_connect = ;
%let _INPUT_engine = BASE;
%let _INPUT_memtype = DATA;
%let _INPUT_options = %nrquote();
%let _INPUT_alter = %nrquote();
%let _INPUT_path = /Users/Manas/My Folder/DIDM_STG/STG_GEO_PROD_VAT(Table);
%let _INPUT_type = 1;

%let _INPUT1 = DIDM_STG.STG_GEO_PROD_VAT;
%let _INPUT1_connect = ;
%let _INPUT1_engine = BASE;
%let _INPUT1_memtype = DATA;
%let _INPUT1_options = %nrquote();
%let _INPUT1_alter = %nrquote();
%let _INPUT1_path = /Users/Manas/My Folder/DIDM_STG/STG_GEO_PROD_VAT(Table);
%let _INPUT1_type = 1;

%let _OUTPUT_count = 1;
%let _OUTPUT = DIDM_STG.STG_GEO_PROD_VAT;
%let _OUTPUT_connect = ;
%let _OUTPUT_engine = BASE;
%let _OUTPUT_memtype = DATA;
%let _OUTPUT_options = %nrquote();
%let _OUTPUT_alter = %nrquote();
%let _OUTPUT_path = /User Written(WorkTable);
%let _OUTPUT_type = 1;
/* List of target columns to keep  */ 
%let _OUTPUT_keep = GEO_ID PROD_ID START_DT VAT_PCT CHANGE_FLG;


%let _OUTPUT1 = DIDM_STG.STG_GEO_PROD_VAT;
%let _OUTPUT1_connect = ;
%let _OUTPUT1_engine = BASE;
%let _OUTPUT1_memtype = DATA;
%let _OUTPUT1_options = %nrquote();
%let _OUTPUT1_alter = %nrquote();
%let _OUTPUT1_path = /User Written(WorkTable);
%let _OUTPUT1_type = 1;
/* List of target columns to keep  */ 
%let _OUTPUT1_keep = GEO_ID PROD_ID START_DT VAT_PCT CHANGE_FLG;


/*---- Start of User Written Code  ----*/ 

%macro etl_check_exist;

   %let abort = 0 ;
   
   /* Check for existence of DI_DM.GEOGRAPHY_DM dataset */
   %if NOT %sysfunc(exist(DI_DM.GEOGRAPHY_DM)) %then 
   %do;
      %let etl_msg = %etl_msg(mid=5005,args=DI_DM.GEOGRRPHY_DM);
    %put &etl_msg;
      %let abort = 1 ;
   %end;

   /* Check for existence of DI_MON.PROD_HIER_SK dataset */
   %if NOT %sysfunc(exist(DI_MON.PROD_HIER_SK)) %then 
   %do;
      %let etl_msg = %etl_msg(mid=5005,args=DI_MON.PROD_HIER_SK);
       %put &etl_msg;
      %let abort = 2 ;
   %end;

   %if &abort gt 0 %then 
   %do;
      %etl_abort;
   %end;

%mend etl_check_exist;
%etl_check_exist;
/*---- End of User Written Code  ----*/ 

%rcSet(&syserr); 
%rcSet(&sqlrc); 


/**  Step end UW_Check_Existence **/

/*============================================================================* 
 * Step:            Lookup                                  A5W0V4GZ.BH000HRJ * 
 * Transform:       Lookup                                                    * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Tables:   User Written -                          A5W0V4GZ.BK000EIU * 
 *                   DIDM_STG.STG_GEO_PROD_VAT                                * 
 *                  GEOGRAPHY_DM - DI_DM.GEOGRAPHY_DM       A5W0V4GZ.BB000809 * 
 *                  PROD_HIER_SK - DI_MON.PROD_HIER_SK      A5W0V4GZ.BB0007U1 * 
 * Target Table:    Lookup - work.LOOKUP_STG_GEO_PROD_VAT   A5W0V4GZ.BK000EIV * 
 *============================================================================*/ 

%macro etls_stg_geo_prod_vat_lkp;

   %let transformID = %quote(A5W0V4GZ.BH000HRJ);
   %let trans_rc = 0;
   %let etls_stepStartTime = %sysfunc(datetime(), datetime20.); 

   %let runTime = %sysfunc(datetime()); 

   proc datasets lib = work nolist nowarn memtype = (data view);
      delete LOOKUP_STG_GEO_PROD_VAT STG_GEO_PROD_VAT_EXCP;
   quit;

   %if %di_util_nobs(DIDM_STG.STG_GEO_PROD_VAT) eq 0 %then %do;
   
      data work.LOOKUP_STG_GEO_PROD_VAT
               ( keep = GEO_ID PROD_ID START_DT VAT_PCT GEO_HIER_SK PROD_HIER_SK CHANGE_FLG )
            ; 

         attrib GEO_ID length=$32
                PROD_ID length=$32
                START_DT length=8 format=DATE9.
                VAT_PCT length=8 format=NLNUM12.4
                GEO_HIER_SK length=4
                PROD_HIER_SK length=6
                CHANGE_FLG length=$1
                ; 
         stop;
      run;
      
   %end;
   
   %else %do;

      /*---- Begin DATA step to perform lookups  ----*/ 
      DATA  work.LOOKUP_STG_GEO_PROD_VAT
               ( keep = GEO_ID PROD_ID START_DT VAT_PCT GEO_HIER_SK PROD_HIER_SK CHANGE_FLG )
            work.STG_GEO_PROD_VAT_EXCP
               ( keep = GEO_ID PROD_ID START_DT VAT_PCT CHANGE_FLG ETLS_EXCEPTION_COND ETL_ERROR_JOBRUNTIME); 

         attrib GEO_ID length=$32
                PROD_ID length=$32
                START_DT length=8 format=DATE9.
                VAT_PCT length=8 format=NLNUM12.4
                GEO_HIER_SK length=4
                PROD_HIER_SK length=6
                CHANGE_FLG length=$1
                ETLS_EXCEPTION_COND length=$100
                ETL_ERROR_JOBRUNTIME length=8 format=DATETIME16.
                ; 

         retain missing0-missing1 0; 

         etls_assign_target_value = 0; 
         /* Build hash objects from lookup tables before reading first source row  */ 
         if (_n_ = 1) then 
         do; 
            /* Build hash h0 from lookup table DI_DM.GEOGRAPHY_DM */ 
            nlobs = .; 
            dsid = open("DI_DM.GEOGRAPHY_DM"); 
            if (dsid > 0) then 
            do; 
               if ( attrc(dsid, 'MTYPE') = 'DATA' ) then 
                  nlobs = attrn(dsid, 'NLOBS'); 
               else 
                  nlobs = -1; 

               dsid = close(dsid); 
               if (nlobs ^= 0) then 
               do; 
                  if (nlobs > 0) then 
                     exponent = ceil(log2(nlobs)); 
                  else 
                     exponent = 8; 
                  declare hash h0(dataset: "DI_DM.GEOGRAPHY_DM", hashexp: exponent);
                  h0.defineKey( "GEO_ID");
                  h0.defineData( "GEO_HIER_SK");
                  h0.defineDone();
                  if (nlobs = -1) then 
                  do; 
                     if (h0.Num_Items < 1) then
                     do; 
                        put "NOTE: Lookup table is empty: DI_DM.GEOGRAPHY_DM";
                        missing0 = 98; 
                     end; 
                  end; 
               end; 
               else 
               do; 
                  put "NOTE: Lookup table is empty: DI_DM.GEOGRAPHY_DM";
                  missing0 = 98; 
               end; 
            end; 
            else 
            do; 
               put "NOTE: Lookup table does not exist or cannot be opened:"
                    " DI_DM.GEOGRAPHY_DM";

               put "NOTE: Abort action indicated, condition= Lookup table missing:"
                    " DI_DM.GEOGRAPHY_DM";

               abort 9999; 
            end; 

            /* Build hash h1 from lookup table DI_MON.PROD_HIER_SK */ 
            nlobs = .; 
            dsid = open("DI_MON.PROD_HIER_SK"); 
            if (dsid > 0) then 
            do; 
               if ( attrc(dsid, 'MTYPE') = 'DATA' ) then 
                  nlobs = attrn(dsid, 'NLOBS'); 
               else 
                  nlobs = -1; 

               dsid = close(dsid); 
               if (nlobs ^= 0) then 
               do; 
                  if (nlobs > 0) then 
                     exponent = ceil(log2(nlobs)); 
                  else 
                     exponent = 8; 
                  declare hash h1(dataset: "DI_MON.PROD_HIER_SK", hashexp: exponent);
                  h1.defineKey( "PROD_ID");
                  h1.defineData( "PROD_HIER_SK");
                  h1.defineDone();
                  if (nlobs = -1) then 
                  do; 
                     if (h1.Num_Items < 1) then
                     do; 
                        put "NOTE: Lookup table is empty: DI_MON.PROD_HIER_SK";
                        missing1 = 98; 
                     end; 
                  end; 
               end; 
               else 
               do; 
                  put "NOTE: Lookup table is empty: DI_MON.PROD_HIER_SK";
                  missing1 = 98; 
               end; 
            end; 
            else 
            do; 
               put "NOTE: Lookup table does not exist or cannot be opened:"
                    " DI_MON.PROD_HIER_SK";

               put "NOTE: Abort action indicated, condition= Lookup table missing:"
                    " DI_MON.PROD_HIER_SK";

               abort 9999; 
            end; 

            call missing (GEO_ID, GEO_HIER_SK, PROD_ID, PROD_HIER_SK); 

         end; /* All hash objects have been defined */

         /* Read a row from the source table  */ 
         set DIDM_STG.STG_GEO_PROD_VAT end = eof;

         /* Is the current key value stored in hash h0?  */ 
         if (missing0 < 1) then 
         do; 
            rc0 = h0.find();
         end; 
         else 
            rc0 = missing0; 

         /* Is the current key value stored in hash h1?  */ 
         if (missing1 < 1) then 
         do; 
            rc1 = h1.find();
         end; 
         else 
            rc1 = missing1; 

         if (missing(geo_hier_sk)) then do; 
            etls_exception_cond = put(cats(etls_exception_cond,'0a'x,"%etl_msg(mid=5306,args=GEO_ID)"),$100.); 
         end;  /* if (MISSING(GEO_HIER_SK)) */

         /*---- Custom Validation: Invalid PROD_ID  ----*/ 
         if (missing(prod_hier_sk)) then do; 
            etls_exception_cond = put(cats(etls_exception_cond,'0a'x,"%etl_msg(mid=5306,args=PROD_ID)"),$100.); 
         end;  /* if (MISSING(PROD_HIER_SK)) */

         /*---- Custom Validation: Invalid VAT_PCT  ----*/ 
         if (not missing(vat_pct) and vat_pct < 0) then do; 
            etls_exception_cond = put(cats(etls_exception_cond,'0a'x,"%etl_msg(mid=5328,args=VAT_PCT ZERO)"),$100.); 
         end;  /* if (NOT MISSING(VAT_PCT) AND VAT_PCT < 0) */
         
         /*---- Custom Validation: Invalid VAT_PCT  ----*/ 
         if (not missing(vat_pct) and vat_pct > 100) then do; 
            etls_exception_cond = put(cats(etls_exception_cond,'0a'x," %etl_msg(mid=5322,args=VAT_PCT 100)"),$100.); 
         end;  /* if (NOT MISSING(VAT_PCT) AND VAT_PCT > 100) */
         
         /*---- Custom Validation: Null VAT_PCT  ----*/ 
         if (missing(vat_pct)) then do; 
            etls_exception_cond = put(cats(etls_exception_cond,'0a'x,"%etl_msg(mid=5305,args=VAT_PCT)"),$100.); 
         end;  /* if VAT_PCT is null */

         /*---- Custom Validation: Remove duplicate  ----*/ 
         if (ETLS_EXCEPTION_COND ne "") then do; 
            ETL_ERROR_JOBRUNTIME = &runTime;
            output work.STG_GEO_PROD_VAT_EXCP;
         end;  
         else do;
            output work.LOOKUP_STG_GEO_PROD_VAT;
         end;   
      
      run; 

      %rcSet(&syserr); 
      
      proc append base = DI_MON.STG_GEO_PROD_VAT_X
                  data = work.STG_GEO_PROD_VAT_EXCP force; 
      run; 

   %end;   /* When stage is not empty */
   
%mend etls_stg_geo_prod_vat_lkp;

%etls_stg_geo_prod_vat_lkp;

/**  Step end Lookup **/

/*============================================================================* 
 * Step:            Sort                                    A5W0V4GZ.BH000HRK * 
 * Transform:       Sort                                                      * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Table:    Lookup - work.LOOKUP_STG_GEO_PROD_VAT   A5W0V4GZ.BK000EIV * 
 * Target Table:    Sort - work.SORTED_STG_GEO_PROD_VAT     A5W0V4GZ.BK000EIW * 
 *============================================================================*/ 

%let transformID = %quote(A5W0V4GZ.BH000HRK);
%let trans_rc = 0;
%let etls_stepStartTime = %sysfunc(datetime(), datetime20.); 

%let SYSLAST = %nrquote(work.LOOKUP_STG_GEO_PROD_VAT); 

%let ETLS_SYSLAST = &SYSLAST;
/*---- Start of Pre-Process Code  ----*/ 

%di_etl_keep_work_table(LOOKUP_STG_GEO_PROD_VAT);
/*---- End of Pre-Process Code  ----*/ 

%rcSet(&syserr); 
%rcSet(&sqlrc); 

%let SYSLAST = &ETLS_SYSLAST;

proc datasets lib = work nolist nowarn memtype = (data view);
   delete SORTED_STG_GEO_PROD_VAT;
quit;

proc sort data = &SYSLAST 
   out = work.SORTED_STG_GEO_PROD_VAT; 
   by
      GEO_HIER_SK
      PROD_HIER_SK
      START_DT
   ;
run; 

%rcSet(&syserr); 



/**  Step end Sort **/

/*============================================================================* 
 * Step:            UW Remove Duplicates                    A5W0V4GZ.BH000HRL * 
 * Transform:       User Written                                              * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Table:    Sort - work.SORTED_STG_GEO_PROD_VAT     A5W0V4GZ.BK000EIW * 
 * Target Table:    User Written -                          A5W0V4GZ.BK000EIX * 
 *                   work.NODUP_STG_GEO_PROD_VAT                              * 
 *                                                                            * 
 * User Written:    SourceCode                                                * 
 *============================================================================*/ 

%let transformID = %quote(A5W0V4GZ.BH000HRL);
%let trans_rc = 0;
%let etls_stepStartTime = %sysfunc(datetime(), datetime20.); 

%let SYSLAST = %nrquote(work.SORTED_STG_GEO_PROD_VAT); 

%let ETLS_SYSLAST = &SYSLAST;
/*---- Start of Pre-Process Code  ----*/ 

%di_etl_keep_work_table(SORTED_STG_GEO_PROD_VAT);
/*---- End of Pre-Process Code  ----*/ 

%rcSet(&syserr); 
%rcSet(&sqlrc); 


proc datasets lib = work nolist nowarn memtype = (data view);
   delete NODUP_STG_GEO_PROD_VAT DUP_STG_GEO_PROD_VAT;
quit;
   
Data work.NODUP_STG_GEO_PROD_VAT (drop = ETLS_EXCEPTION_COND ETL_ERROR_JOBRUNTIME PROD_ID GEO_ID)
     work.DUP_STG_GEO_PROD_VAT (drop = PROD_HIER_SK GEO_HIER_SK);
   attrib ETLS_EXCEPTION_COND length = $100 
          ETL_Error_JobRunTime length = 8 format = datetime16.; 
          
   set work.SORTED_STG_GEO_PROD_VAT;
   by GEO_HIER_SK PROD_HIER_SK START_DT ;
   
   if not last.START_DT then do;
      ETLS_EXCEPTION_COND = "%etl_msg(mid=5351)";
      ETL_Error_JobRunTime = "&etls_stepStartTime"dt; 
      output work.DUP_STG_GEO_PROD_VAT;
   end;
   else do;
      output work.NODUP_STG_GEO_PROD_VAT;
   end;
   
run;

proc append base = DI_MON.STG_GEO_PROD_VAT_X
            data = work.DUP_STG_GEO_PROD_VAT force;
run;            

/*---- End of User Written Code  ----*/ 

%rcSet(&syserr); 
%rcSet(&sqlrc); 

/**  Step end UW Remove Duplicates **/

/*============================================================================* 
 * Step:            UW Assign END_DT                        A5W0V4GZ.BH000HRN * 
 * Transform:       User Written                                              * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Table:    Data Validation -                       A5W0V4GZ.BK000EIY * 
 *                   work.DATVAL_STG_GEO_PROD_VAT                             * 
 * Target Table:    User Written -                          A5W0V4GZ.BK000EIZ * 
 *                   work.POPULATE_END_DT_STG_GEO_PROD_VAT                    * 
 *                                                                            * 
 * User Written:    SourceCode                                                * 
 *============================================================================*/ 

%let transformID = %quote(A5W0V4GZ.BH000HRN);
%let trans_rc = 0;
%let etls_stepStartTime = %sysfunc(datetime(), datetime20.); 

/*---- Start of Pre-Process Code  ----*/ 

%di_etl_keep_work_table(NODUP_STG_GEO_PROD_VAT);
/*---- End of Pre-Process Code  ----*/ 

%rcSet(&syserr); 
%rcSet(&sqlrc); 

/*---- Start of User Written Code  ----*/ 
%macro etls_merge_geo_prod_vat(source=);

   %if %eval(%di_util_nobs(&source) gt 0) %then %do;

      data work.merged_geo_prod_vat;
         merge di_dm.geo_prod_vat 
               &source;

         by geo_hier_sk prod_hier_sk start_dt;
         if end_dt eq . then end_dt='01JAN5999'd;
         if upcase(change_flg)="&etl_delete_flg" then delete;
         else output;
      run;

      %rcSet(&syserr); 
      %rcSet(&sqlrc); 

      data work.populate_end_dt_stg_geo_prod_vat ;

         attrib last_start length=8 format = date9. last_end length=8 format = date9. row_output length=$2;
         retain last_start . last_end . row_output '';

         set work.merged_geo_prod_vat;
         by geo_hier_sk prod_hier_sk;

         if first.prod_hier_sk or last_start=. or row_output = 'Y' then last_start=start_dt;
         if first.prod_hier_sk or last_end=. or row_output = 'Y' then last_end=end_dt;

         /* close out any history records if they exist */ 
         if not last.prod_hier_sk then do;
            obsnum = _n_ + 1;
            set merged_geo_prod_vat(keep = start_dt end_dt vat_pct
                                rename = (start_dt = next_start_dt 
                                          end_dt = next_end_dt 
                                          vat_pct = next_vat_pct))
                                point = obsnum;

            if (vat_pct ne next_vat_pct) then do;

               start_dt = last_start;
               end_dt = next_start_dt - 1;
               row_output = 'Y';
            end;
            else do;   /* vat_pct are same */
               if end_dt > next_end_dt then do;
                  last_end = end_dt;
               end;
               if last_end > end_dt and row_output = 'N' then do;
                  end_dt = last_end;
               end;
               start_dt = last_start;
               row_output = 'N';
            end;
         end;
         else do;
            if row_output ne 'Y' then do;
               start_dt = last_start;
               if last_end > end_dt and row_output = 'N' then do;
                  end_dt = last_end;
               end;
               row_output = 'Y';
            end;
         end;
         drop last_start next_start_dt next_end_dt next_vat_pct last_end next_end_dt row_output change_flg;
         if row_output = 'Y';

      run;
   
   %end;
   
   %else %do;
   
      data work.populate_end_dt_stg_geo_prod_vat;
         attrib GEO_HIER_SK length=4
                PROD_HIER_SK length=6
                START_DT length=8 format=DATE9.
                END_DT length=8 format=DATE9.                
                VAT_PCT length=8 format=NLNUM12.4
                ; 
         stop;
      run;
   
   %end;

%mend etls_merge_geo_prod_vat;

%etls_merge_geo_prod_vat(source=work.NODUP_STG_GEO_PROD_VAT);

/*---- End of User Written Code  ----*/ 

%rcSet(&syserr); 
%rcSet(&sqlrc); 


/**  Step end UW Assign END_DT **/

/*============================================================================* 
 * Step:            Table Loader                                              * 
 * Transform:       Table Loader                                              * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Table:    User Written -                                            * 
 *                   work.POPULATE_END_DT_STG_GEO_PROD_VAT                    * 
 * Target Table:    GEO_PROD_VAT - DI_DM.GEO_PROD_VAT                         * 
 *============================================================================*/ 

 %let trans_rc = 0;
%let etls_stepStartTime = %sysfunc(datetime(), datetime20.); 

%let SYSLAST = %nrquote(work.POPULATE_END_DT_STG_GEO_PROD_VAT); 

/*---- Start of Pre-Process Code  ----*/ 

%di_etl_keep_work_table(POPULATE_END_DT_STG_GEO_PROD_VAT);
/*---- End of Pre-Process Code  ----*/ 

%rcSet(&syserr); 
%rcSet(&sqlrc); 

%macro etls_loader_geo_prod_vat(source=);

   /* Get number of records in table  */ 
   %local etls_source_rec;  
   %let etls_recordsBefore = 0; 

   %let etls_recordsBefore = %di_util_nobs(DI_DM.GEO_PROD_VAT);
   %let etls_source_rec = %di_util_nobs(&source);
   
   %let etls_table = %nrquote(GEO_PROD_VAT);
   %let etls_lib   = %nrquote(DI_DM);
   
   /*---- Map the columns  ----*/ 
   proc datasets lib = work nolist nowarn memtype = (data view);
      delete W5RX9ZJ8;
   quit;
   
   %put %str(NOTE: Mapping columns ...);
   proc sql;
      create view work.W5RX9ZJ8 as
         select
            GEO_HIER_SK,
            PROD_HIER_SK,
            START_DT   
               informat = DATE9.,
            END_DT,
            VAT_PCT
      from &source
      ;
   quit;
   
   /* Determine if the target table exists  */ 
   %let etls_tableExist = %eval(%sysfunc(exist(DI_DM.GEO_PROD_VAT, DATA)) or 
         %sysfunc(exist(DI_DM.GEO_PROD_VAT, VIEW))); 
   
   %if &etls_tableExist eq 0 %then %do;
      
      %etl_create2(_sasschemafile = &etlp_ddl_path, 
                   _tableName     = GEO_PROD_VAT, 
                   _dataset       = 1, 
                   _constraints   = 1,
                   _index         = 1,
                   libref         = DI_DM,
                   dttmfmt        = NLDATM21.,
                   dtfmt          = DATE9.);      
      
   %end;

   /* If source has records then replace the target table */   
   %if %eval(&etls_source_rec gt 0) %then %do;
       
      %etl_drop(DI_DM.GEO_PROD_VAT,ic);
      %etl_drop(DI_DM.GEO_PROD_VAT,index);  
      
      %di_util_truncate_table(DI_DM.GEO_PROD_VAT);
       
      %rcSet(&syserr); 
      
      %put %str(NOTE: Appending data ...);

      proc append base = DI_DM.GEO_PROD_VAT 
                  data = work.W5RX9ZJ8 force; 
      run; 

      %rcSet(&syserr); 

      /*---- Create the indexes for a table  ----*/ 
      %put %str(NOTE: Creating indexes ...);
      proc datasets lib = DI_DM nolist; 
         modify GEO_PROD_VAT; 
            index create GP_IDX = (GEO_HIER_SK PROD_HIER_SK);
      quit; 

      %rcSet(&syserr); 

      /*---- Create the integrity constraints for a table  ----*/ 
      %put %str(NOTE: Creating integrity constraints ...);
      proc datasets library=DI_DM nolist;
         modify GEO_PROD_VAT;
            ic create not null (GEO_HIER_SK);
            ic create not null (PROD_HIER_SK);
            ic create not null (START_DT);
            ic create PRIM_KEY = primary key (GEO_HIER_SK PROD_HIER_SK START_DT);
      quit;

      %rcSet(&syserr); 
   
   %end; 

   %let etls_recordsAfter = 0; 
   %let etls_recordsAfter = %di_util_nobs(DI_DM.GEO_PROD_VAT);

%mend etls_loader_geo_prod_vat;

%etls_loader_geo_prod_vat(source=work.POPULATE_END_DT_STG_GEO_PROD_VAT);


/**  Step end Table Loader **/

%let etls_endTime = %sysfunc(datetime(),datetime.);

/*---- Job status macro  ----*/ 
%etls_sendJobStatus(source_table = didm_stg.stg_geo_prod_vat);
