/* 
SUPPORT: sinsro Rokde, Sangeeta
*/ 
/****************************************************************************** 
 * Job:             Load_STG2DM_Geography_dm                A5RCIHUB.BA0002VA * 
 * Source Tables:   GEOGRAPHY_DM - DI_DM.GEOGRAPHY_DM       A5RCIHUB.BR0004D3 * 
 *                  STG_GEOGRAPHY_HIERARCHY -               A5RCIHUB.BR0004HI * 
 *                   DIDM_STG.STG_GEOGRAPHY_HIERARCHY                         * 
 *                  GEOGRAPHY_HIER_ASSOC_DM -               A5RCIHUB.BR0004D4 * 
 *                   DI_DM.GEOGRAPHY_HIER_ASSOC_DM                            * 
 *                  STG_GEOGRAPHY - DIDM_STG.STG_GEOGRAPHY  A5RCIHUB.BR0004HF * 
 * Target Table:    GEOGRAPHY_DM - DI_DM.GEOGRAPHY_DM       A5RCIHUB.BR0004D3 * 
 *                                                                            * 
 * Generated on:    Thursday, January 29, 2009 2:20:33 PM IST                 * 
 * Generated by:    sinsro@ROW                                                * 
 * Version:         SAS Data Integration Studio 4.2                           * 
 ******************************************************************************/ 

/* General macro variables  */ 
%let jobID = %quote(A5RCIHUB.BA0002VA);
%let etls_jobName = %nrquote(Load_STG2DM_Geography_dm);
%let etls_userID = %nrquote(sinsro@ROW);

/* Setup to capture return codes  */ 
%global job_rc trans_rc sqlrc; 
%let sysrc = 0;
%let job_rc = 0;
%let trans_rc = 0;
%let sqlrc = 0;
%global syserr; 

%macro rcSet(error); 
   %if (&error gt &trans_rc) %then 
      %let trans_rc = &error;
   %if (&error gt &job_rc) %then 
      %let job_rc = &error;
%mend rcSet; 

%macro rcSetDS(error); 
   if &error gt input(symget('trans_rc'),12.) then 
      call symput('trans_rc',trim(left(put(&error,12.))));
   if &error gt input(symget('job_rc'),12.) then 
      call symput('job_rc',trim(left(put(&error,12.))));
%mend rcSetDS; 

%let IOMServer = %nrquote(MIMain);

/* Setup for capturing job status  */ 
%let etls_startTime = %sysfunc(datetime(),datetime.);
%let etls_recordsBefore = 0;
%let etls_recordsAfter = 0;
%let etls_lib = 0;
%let etls_table = 0;

%global etls_debug; 
%macro etls_setDebug; 
   %if %str(&etls_debug) ne 0 %then 
      OPTIONS MPRINT%str(;); 
%mend; 
%etls_setDebug; 

/*---- Start of Pre-Process Code  ----*/ 

/**/
%etl_initjobparam (monlib=di_mon, jobname=%nrquote(&etls_jobName));
/**/
%etl_initchangeflags;
/*---- End of Pre-Process Code  ----*/ 

%rcSet(&syserr); 
%rcSet(&sqlrc); 

/*============================================================================* 
 * Step:            UW_check_exist                          A5RCIHUB.BC000E5G * 
 * Transform:       User Written                                              * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Table:    STG_GEOGRAPHY - DIDM_STG.STG_GEOGRAPHY  A5RCIHUB.BR0004HF * 
 * Target Table:    User Written - DIDM_STG.STG_GEOGRAPHY   A5RCIHUB.BE000BLX * 
 *                                                                            * 
 * User Written:    SourceCode                                                * 
 *============================================================================*/ 

%let etls_stepStartTime = %sysfunc(datetime(), datetime20.); 

/*---- Start of User Written Code  ----*/ 

%global g_max_std_hier_geo_lvl g_valid_geo_lvls g_geo_low_lvl_store_flg ;

%macro check_exist;
   
%let abort = 0 ;
   
/* Check for existence of DI_DM.GEOGRAPHY_LVL dataset */
%if NOT %sysfunc(exist(DI_DM.GEOGRAPHY_LVL)) %then 
%do;
   %let etl_msg = %etl_msg(mid=5005,args=DI_DM.GEOGRAPHY_LVL);
   %put &etl_msg;
   %let abort = 1 ;
%end;
%else %do;
   %let geography_lvl_obs = %di_util_nobs(DI_DM.GEOGRAPHY_LVL);
   %if &geography_lvl_obs = 0 %then 
   %do;
      %let etl_msg = %etl_msg(mid=5008,args=DI_DM.GEOGRAPHY_LVL);
      %put &etl_msg;
      %let abort = 2 ;
   %end;
   %else %do;
      proc sql noprint;
         select max(geo_lvl) into :g_max_std_hier_geo_lvl
         from di_dm.geography_lvl
           where geo_hier_assoc_cd = 1;
      quit;
      %if &g_max_std_hier_geo_lvl eq %str() %then
      %do;
         %let etl_msg = %etl_msg(mid=5012,args=Geo_lvl Geography_lvl);
         %put &etl_msg;
         %let abort = 3 ;
      %end;
      %else %do;
         proc sql noprint;
            select geo_lvl into :g_valid_geo_lvls separated by ','
            from di_dm.geography_lvl
            where geo_hier_assoc_cd = 1;
         quit;
      %end;
      %if &g_valid_geo_lvls eq %str() %then
      %do;
         %let etl_msg = %etl_msg(mid=5012,args=Geo_lvl Geography_lvl);
         %put &etl_msg;
         %let abort = 4 ;
         %end;
      %end;
   %end;
/*Get the value of GEO_LOW_LVL_STORE_FLG from global_setting*/
PROC SQL noprint;
   select spec_value into :g_geo_low_lvl_store_flg
   from di_dm.global_setting
   where upcase(spec_nm)='GEO_LOW_LVL_STORE_FLG';
QUIT;

/* validation for GEO_PROD_LOW_DATA_LVL */
%if &g_geo_low_lvl_store_flg eq %str() %then
  %do;
    %let etl_msg = %etl_msg(mid=5013,args=GEO_LOW_LVL_STORE_FLG GLOBAL_SETTING);
    %put &etl_msg;
  %end;   

%put g_geo_low_lvl_store_flg=&g_geo_low_lvl_store_flg;
%put g_max_std_hier_geo_lvl =&g_max_std_hier_geo_lvl;
%put G_VALID_GEO_LVLS=&g_valid_geo_lvls;

/* Get the length of exception msg variable in exception table */
   %global len_excp_msg1;

   data _null_;
      dsid=open("&etlp_exception_table","I", ,'D');
      num=attrn(dsid,"nvars");
      do i=1 to num;
         name=varname(dsid,i);
         if upcase(name) = 'ETLS_EXCEPTION_COND' then do;
            len_excp_msg1 = varlen(dsid,i);
            call symput('len_excp_msg1',compress(len_excp_msg1));
         end;
      end;
      rc=close(dsid);
   run;
   %let len_excp_msg1=&len_excp_msg1;
   %put len_excp_msg1=&len_excp_msg1;

   %if %eval(&len_excp_msg1 le 0) %then %do;
      %let etl_msg = %etl_msg(mid=5013,args=ETLS_EXCEPTION_COND &etlp_exception_table);
      %put &etl_msg;
      %let abort = 3;
   %end;
   
%if &abort gt 0 %then 
%do;
      %etl_abort;
%end;
   
%mend check_exist;
   
%check_exist;

%global etls_recordsBefore1 GEO_ID_1_LVL;

%macro create_global_var;

   %let etls_recordsBefore1=%di_util_nobs(DI_DM.GEOGRAPHY_DM);
   %if &etls_recordsBefore1 > 0 %then %do;
      proc sql noprint;
      select GEO_ID into :GEO_ID_1_LVL 
      from DI_DM.GEOGRAPHY_DM 
      where STD_HIER_GEO_LVL=1;
      quit;
   %end;
   %let GEO_ID_1_LVL = &GEO_ID_1_LVL;
   %put GEO_ID_1_LVL = &GEO_ID_1_LVL;

%mend create_global_var;

%create_global_var;

/*---- End of User Written Code  ----*/ 

%rcSet(&syserr); 
%rcSet(&sqlrc); 


/**  Step end UW_check_exist **/

/*============================================================================* 
 * Step:            Sort_Geo_id                             A5RCIHUB.BC000E5H * 
 * Transform:       Sort                                                      * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Table:    User Written - DIDM_STG.STG_GEOGRAPHY   A5RCIHUB.BE000BLX * 
 * Target Table:    Sort_Geo_id - work.Sort_Geo_id          A5RCIHUB.BE000BLY * 
 *============================================================================*/ 

%let trans_rc = 0;
%let etls_stepStartTime = %sysfunc(datetime(), datetime20.); 

proc datasets lib = work nolist nowarn memtype = (data view);
   delete Sort_Geo_id;
quit;

proc sort data = DIDM_STG.STG_GEOGRAPHY 
   out = work.Sort_Geo_id; 
   by
      GEO_ID
      OPEN_DT
   ;
run; 

%rcSet(&syserr); 



/**  Step end Sort_Geo_id **/

/*============================================================================* 
 * Step:            Uw_remove_duplicates                    A5RCIHUB.BC000E5I * 
 * Transform:       User Written                                              * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Table:    Sort_Geo_id - work.Sort_Geo_id          A5RCIHUB.BE000BLY * 
 * Target Table:    Uw_remove_duplicates -                  A5RCIHUB.BE000BLZ * 
 *                   work.Uw_remove_duplicates                                * 
 *                                                                            * 
 * User Written:    SourceCode                                                * 
 *============================================================================*/ 

%let transformID = %quote(A5RCIHUB.BC000E5I);
%let trans_rc = 0;
%let etls_stepStartTime = %sysfunc(datetime(), datetime20.); 

/*---- Start of Pre-Process Code  ----*/ 

%di_etl_keep_work_table(Sort_Geo_id);

/*---- End of Pre-Process Code  ----*/ 

%rcSet(&syserr); 
%rcSet(&sqlrc); 

/*---- Start of User Written Code  ----*/ 

proc datasets lib = work nolist nowarn memtype = (data view);
   delete STG_GEOGRAPHY_DUPS;
quit;

data Uw_remove_duplicates(drop=ETLS_EXCEPTION_COND ETL_ERROR_JOBRUNTIME)
     WORK.STG_GEOGRAPHY_DUPS(keep=%di_util_column_names(DI_MON.STG_GEOGRAPHY_X));
set Sort_Geo_id;
retain lvl_1_count 0;
attrib ETLS_EXCEPTION_COND length = $&len_excp_msg1.;
attrib ETL_ERROR_JOBRUNTIME length = 8 format=datetime16.; 

by GEO_ID;

if last.GEO_ID and STD_HIER_GEO_LVL NE 1 then output Uw_remove_duplicates;
else if not(last.GEO_ID) then 
   do;
      ETLS_EXCEPTION_COND = cats(ETLS_EXCEPTION_COND,'0a'x," * %etl_msg(mid=5303,args=GEO_ID)"); 	  
      ETL_ERROR_JOBRUNTIME = "&etls_stepStartTime"dt;
      output WORK.STG_GEOGRAPHY_DUPS;
   end;
else if STD_HIER_GEO_LVL = 1 then 
   do;
      if lvl_1_count=0 then 
         do;
           lvl_1_count+1;
           output Uw_remove_duplicates;
         end;
      else do;
            ETLS_EXCEPTION_COND = cats(ETLS_EXCEPTION_COND,'0a'x," * %etl_msg(mid=5303,args=STD_HIER_GEO_LVL=1)");			
            ETL_ERROR_JOBRUNTIME = "&etls_stepStartTime"dt;
            output WORK.STG_GEOGRAPHY_DUPS;
         end;
   end;
run;

proc append base = DI_MON.STG_GEOGRAPHY_X 
            data=WORK.STG_GEOGRAPHY_DUPS force; 
run; 

/*---- End of User Written Code  ----*/ 

%rcSet(&syserr); 
%rcSet(&sqlrc); 


/**  Step end Uw_remove_duplicates **/

/*============================================================================* 
 * Step:            Lkp_geography_dm                        A5RCIHUB.BC000E5J * 
 * Transform:       Lookup                                                    * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Tables:   Uw_remove_duplicates -                  A5RCIHUB.BE000BLZ * 
 *                   work.Uw_remove_duplicates                                * 
 *                  GEOGRAPHY_DM - DI_DM.GEOGRAPHY_DM       A5RCIHUB.BR0004D3 * 
 *                  STG_GEOGRAPHY_HIERARCHY -               A5RCIHUB.BR0004HI * 
 *                   DIDM_STG.STG_GEOGRAPHY_HIERARCHY                         * 
 * Target Table:    Lkp_geography_dm -                      A5RCIHUB.BE000BM0 * 
 *                   work.Lkp_geography_dm                                    * 
 *============================================================================*/ 

%let etls_stepStartTime = %sysfunc(datetime(), datetime20.); 

/*---- Start of Pre-Process Code  ----*/ 

%di_etl_keep_work_table(Uw_remove_duplicates);

/*---- End of Pre-Process Code  ----*/ 

%rcSet(&syserr); 
%rcSet(&sqlrc); 

%let runTime = %sysfunc(datetime()); 

/* Creating view to eliminate column name collisions for lookup table  */ 
/*  DI_DM.GEOGRAPHY_DM                                                 */ 
proc datasets lib = work nolist nowarn memtype = (data view);
   delete etls_temp_lookupview0;
quit;

proc sql; create view etls_temp_lookupview0 as 
   select 
      GEO_HIER_SK,
      STD_HIER_GEO_LVL as ext_std_geo_lvl,      
      CLOSING_DT as ext_close_dt,
      GEO_ID
   from DI_DM.GEOGRAPHY_DM
   ;
quit;
proc datasets lib = work nolist nowarn memtype = (data view);
   delete etls_temp_lookupview1;
quit;

proc sql; create view etls_temp_lookupview1 as 
   select * from DIDM_STG.STG_GEOGRAPHY_HIERARCHY
   where GEO_HIER_ASSOC_CD = 1;
quit;
proc datasets lib = work nolist nowarn memtype = (data view);
   delete Lkp_geography_dm;
quit;

/*---- Begin DATA step to perform lookups  ----*/ 
DATA  work.Lkp_geography_dm
         ( keep = GEO_ID GEO_NM STD_HIER_GEO_LVL FACILITY_TYPE SIZE_OF_FACILITY OPEN_DT 
                 CLOSING_DT STREET_ADDRESS CITY STATE ZIP_CODE COUNTRY STG_STD_GEO_LVL 
                 GEO_HIER_SK DM_STD_HIER_GEO_LVL DM_CLOSE_DT)
      ; 
   
   attrib GEO_ID length=$32
          GEO_NM length=$40
          STD_HIER_GEO_LVL length=4
          FACILITY_TYPE length=4
          SIZE_OF_FACILITY length=8 format=NLNUM12.2
          OPEN_DT length=8 format=DATE9.
          CLOSING_DT length=8 format=DATE9.
          STREET_ADDRESS length=$100
          CITY length=$20
          STATE length=$20
          ZIP_CODE length=$20
          COUNTRY length=$20
          STG_STD_GEO_LVL length=4
          GEO_HIER_SK length=4
          DM_STD_HIER_GEO_LVL length=4
          DM_CLOSE_DT length=8 format=DATE9.
          ext_std_geo_lvl length= 4
          ext_close_dt length= 8
          GEO_LVL length= 4
          ; 
   
   retain missing0-missing1 0; 
   
   etls_assign_target_value = 0; 
   /* Build hash objects from lookup tables before reading first source row  */ 
   if (_n_ = 1) then 
   do; 
      /* Build hash h0 from lookup table etls_temp_lookupview0 */ 
      nlobs = .; 
      dsid = open("etls_temp_lookupview0"); 
      if (dsid > 0) then 
      do; 
         if ( attrc(dsid, 'MTYPE') = 'DATA' ) then 
            nlobs = attrn(dsid, 'NLOBS'); 
         else 
            nlobs = -1; 
            
         dsid = close(dsid); 
         if (nlobs ^= 0) then 
         do; 
            if (nlobs > 0) then 
               exponent = ceil(log2(nlobs)); 
            else 
               exponent = 8; 
            declare hash h0(dataset: "etls_temp_lookupview0", hashexp: exponent);
            h0.defineKey( "GEO_ID");
            h0.defineData( "GEO_HIER_SK",
                           "ext_std_geo_lvl",
                           "ext_close_dt");
            h0.defineDone();
            if (nlobs = -1) then 
            do; 
               if (h0.Num_Items < 1) then
               do; 
                  put "NOTE: Lookup table is empty: etls_temp_lookupview0";
                  missing0 = 98; 
               end; 
            end; 
         end; 
         else 
         do; 
            put "NOTE: Lookup table is empty: etls_temp_lookupview0";
            missing0 = 98; 
         end; 
      end; 
      else 
      do; 
         put "NOTE: Lookup table does not exist or cannot be opened:"
              " etls_temp_lookupview0";
         
         put "NOTE: Abort action indicated, condition= Lookup table missing:"
              " etls_temp_lookupview0";
         
         abort 3; 
      end; 
      
      /* Build hash h1 from lookup table etls_temp_lookupview1 */ 
      nlobs = .; 
      dsid = open("etls_temp_lookupview1"); 
      if (dsid > 0) then 
      do; 
         if ( attrc(dsid, 'MTYPE') = 'DATA' ) then 
            nlobs = attrn(dsid, 'NLOBS'); 
         else 
            nlobs = -1; 
            
         dsid = close(dsid); 
         if (nlobs ^= 0) then 
         do; 
            if (nlobs > 0) then 
               exponent = ceil(log2(nlobs)); 
            else 
               exponent = 8; 
            declare hash h1(dataset: "etls_temp_lookupview1", hashexp: exponent);
            h1.defineKey( "GEO_ID");
            h1.defineData( "GEO_LVL");
            h1.defineDone();
            if (nlobs = -1) then 
            do; 
               if (h1.Num_Items < 1) then
               do; 
                  put "NOTE: Lookup table is empty: etls_temp_lookupview1";
                  missing1 = 98; 
               end; 
            end; 
         end; 
         else 
         do; 
            put "NOTE: Lookup table is empty: etls_temp_lookupview1";
            missing1 = 98; 
         end; 
      end; 
      else 
      do; 
         put "NOTE: Lookup table does not exist or cannot be opened:"
              " etls_temp_lookupview1";
         
         put "NOTE: Abort action indicated, condition= Lookup table missing:"
              " etls_temp_lookupview1";
         
         abort 3; 
      end; 
      
      call missing (GEO_ID, GEO_HIER_SK, ext_std_geo_lvl, ext_close_dt, GEO_LVL); 
   
   end; /* All hash objects have been defined */
   
   /* Read a row from the source table  */ 
   set work.Uw_remove_duplicates end = eof;
   
   /* Is the current key value stored in hash h0?  */ 
   if (missing0 < 1) then 
   do; 
      rc0 = h0.find();
      DM_STD_HIER_GEO_LVL = ext_std_geo_lvl;
      DM_CLOSE_DT = ext_close_dt;
   end; 
   else 
      rc0 = missing0; 
      
   /* Is the current key value stored in hash h1?  */ 
   if (missing1 < 1) then 
   do; 
      rc1 = h1.find();
      STG_STD_GEO_LVL = GEO_LVL;
   end; 
   else 
      rc1 = missing1; 
      
   /* Examine success of lookups  */ 
   if ( rc0=0 and rc1=0 ) then 
   do; 
      /* Write row to target  */ 
      output work.Lkp_geography_dm; 
      return; 
   end; 
   else 
   do; 
      error_total + 1; 
      
      if (rc0 ^= 0) then 
      do; 
         exception_total + 1; 
         if (rc0 = 98) then 
         do; 
            /* Check: Lookup table has no rows-Write exception row  */ 
            /* Check: Lookup table has no rows-Set target columns to value  */ 
            /* Check: Lookup table has no rows-Set target columns to missing  */ 
            call missing (GEO_HIER_SK, DM_STD_HIER_GEO_LVL, DM_CLOSE_DT); 
            etls_assign_target_value = 1; 
         end; 
         
         else 
         do; 
            /* Check: Lookup value not found-Set target columns to missing  */ 
            call missing (GEO_HIER_SK, DM_STD_HIER_GEO_LVL, DM_CLOSE_DT); 
            etls_assign_target_value = 1; 
         end; 
      end; 
      
      if (rc1 ^= 0) then 
      do; 
         exception_total + 1; 
         if (rc1 = 98) then 
         do; 
            /* Check: Lookup table has no rows-Write exception row  */ 
            /* Check: Lookup table has no rows-Set target columns to value  */ 
            /* Check: Lookup table has no rows-Set target columns to missing  */ 
            call missing (STG_STD_GEO_LVL); 
            etls_assign_target_value = 1; 
         end; 
         
         else 
         do; 
            /* Check: Lookup value not found-Set target columns to missing  */ 
            call missing (STG_STD_GEO_LVL); 
            etls_assign_target_value = 1; 
         end; 
      end; 
      
      /* Set target columns to value/missing requested?  */ 
      if (etls_assign_target_value eq 1) then 
         /* Write row to target  */ 
         output work.Lkp_geography_dm; 
   
   end; /* One or more lookups failed */
   
   if (eof = 1) then 
   do; 
      put "Source records with errors: " error_total ; 
      put "Total lookup exceptions: " exception_total ; 
   end; 

run; 

%rcSet(&syserr); 



/**  Step end Lkp_geography_dm **/

/*============================================================================* 
 * Step:            Lkp_geo_hier_assoc_dm                   A5RCIHUB.BC000E5K * 
 * Transform:       Lookup                                                    * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Tables:   Lkp_geography_dm -                      A5RCIHUB.BE000BM0 * 
 *                   work.Lkp_geography_dm                                    * 
 *                  GEOGRAPHY_HIER_ASSOC_DM -               A5RCIHUB.BR0004D4 * 
 *                   DI_DM.GEOGRAPHY_HIER_ASSOC_DM                            * 
 * Target Table:    Lkp_geo_hier_assoc_dm -                 A5RCIHUB.BE000BM1 * 
 *                   work.Lkp_geo_hier_assoc_dm                               * 
 *============================================================================*/ 

%let etls_stepStartTime = %sysfunc(datetime(), datetime20.); 

/*---- Start of Pre-Process Code  ----*/ 

%di_etl_keep_work_table(Lkp_geography_dm);

/*---- End of Pre-Process Code  ----*/ 

%rcSet(&syserr); 
%rcSet(&sqlrc); 

%let runTime = %sysfunc(datetime()); 

proc datasets lib = work nolist nowarn memtype = (data view);
   delete etls_temp_lookupview0;
quit;

proc sql; create view etls_temp_lookupview0 as 
   select * from DI_DM.GEOGRAPHY_HIER_ASSOC_DM
   where GEO_HIER_ASSOC_CD = 1;
quit;

proc datasets lib = work nolist nowarn memtype = (data view);
   delete Lkp_geo_hier_assoc_dm;
quit;

/*---- Begin DATA step to perform lookups  ----*/ 
DATA  work.Lkp_geo_hier_assoc_dm
         ( keep = GEO_ID GEO_NM STD_HIER_GEO_LVL FACILITY_TYPE SIZE_OF_FACILITY OPEN_DT 
                 CLOSING_DT STREET_ADDRESS CITY STATE ZIP_CODE COUNTRY STG_STD_GEO_LVL 
                 GEO_HIER_SK DM_STD_HIER_GEO_LVL DM_CLOSE_DT DM_STD_GEO_LVL )
      ; 
   
   attrib GEO_ID length=$32
          GEO_NM length=$40
          STD_HIER_GEO_LVL length=4
          FACILITY_TYPE length=4
          SIZE_OF_FACILITY length=8 format=NLNUM12.2
          OPEN_DT length=8 format=DATE9.
          CLOSING_DT length=8 format=DATE9.
          STREET_ADDRESS length=$100
          CITY length=$20
          STATE length=$20
          ZIP_CODE length=$20
          COUNTRY length=$20
          STG_STD_GEO_LVL length=4
          GEO_HIER_SK length=4
          DM_STD_HIER_GEO_LVL length=4
          DM_CLOSE_DT length=8 format=DATE9.
          DM_STD_GEO_LVL length=4
          GEO_LVL length= 4
          ; 
   
   retain missing0-missing0 0; 
   
   etls_assign_target_value = 0; 
   /* Build hash objects from lookup tables before reading first source row  */ 
   if (_n_ = 1) then 
   do; 
      /* Build hash h0 from lookup table etls_temp_lookupview0 */ 
      nlobs = .; 
      dsid = open("etls_temp_lookupview0"); 
      if (dsid > 0) then 
      do; 
         if ( attrc(dsid, 'MTYPE') = 'DATA' ) then 
            nlobs = attrn(dsid, 'NLOBS'); 
         else 
            nlobs = -1; 
            
         dsid = close(dsid); 
         if (nlobs ^= 0) then 
         do; 
            if (nlobs > 0) then 
               exponent = ceil(log2(nlobs)); 
            else 
               exponent = 8; 
            declare hash h0(dataset: "etls_temp_lookupview0", hashexp: exponent);
            h0.defineKey( "GEO_HIER_SK");
            h0.defineData( "GEO_LVL");
            h0.defineDone();
            if (nlobs = -1) then 
            do; 
               if (h0.Num_Items < 1) then
               do; 
                  put "NOTE: Lookup table is empty: etls_temp_lookupview0";
                  missing0 = 98; 
               end; 
            end; 
         end; 
         else 
         do; 
            put "NOTE: Lookup table is empty: etls_temp_lookupview0";
            missing0 = 98; 
         end; 
      end; 
      else 
      do; 
         put "NOTE: Lookup table does not exist or cannot be opened:"
              " etls_temp_lookupview0";
         
         put "NOTE: Abort action indicated, condition= Lookup table missing:"
              " etls_temp_lookupview0";
         
         abort 3; 
      end; 
      
      call missing (GEO_HIER_SK, GEO_LVL); 
   
   end; /* All hash objects have been defined */
   
   /* Read a row from the source table  */ 
   set work.Lkp_geography_dm end = eof;
   
   /* Is the current key value stored in hash h0?  */ 
   if (missing0 < 1) then 
   do; 
      rc0 = h0.find();
      DM_STD_GEO_LVL = GEO_LVL;
   end; 
   else 
      rc0 = missing0; 
      
   /* Examine success of lookups  */ 
   if ( rc0=0 ) then 
   do; 
      /* Write row to target  */ 
      output work.Lkp_geo_hier_assoc_dm; 
      return; 
   end; 
   else 
   do; 
      error_total + 1; 
      
      if (rc0 ^= 0) then 
      do; 
         exception_total + 1; 
         if (rc0 = 98) then 
         do; 
            /* Check: Lookup table has no rows-Write exception row  */ 
            /* Check: Lookup table has no rows-Set target columns to value  */ 
            /* Check: Lookup table has no rows-Set target columns to missing  */ 
            call missing (DM_STD_GEO_LVL); 
            etls_assign_target_value = 1; 
         end; 
         
         else 
         do; 
            /* Check: Lookup value not found-Set target columns to missing  */ 
            call missing (DM_STD_GEO_LVL); 
            etls_assign_target_value = 1; 
         end; 
      end; 
      
      /* Set target columns to value/missing requested?  */ 
      if (etls_assign_target_value eq 1) then 
         /* Write row to target  */ 
         output work.Lkp_geo_hier_assoc_dm; 
   
   end; /* One or more lookups failed */
   
   if (eof = 1) then 
   do; 
      put "Source records with errors: " error_total ; 
      put "Total lookup exceptions: " exception_total ; 
   end; 

run; 

%rcSet(&syserr); 



/**  Step end Lkp_geo_hier_assoc_dm **/

/*============================================================================* 
 * Step:            Val_geography_dm                        A5RCIHUB.BC000E5L * 
 * Transform:       Data Validation                                           * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Table:    Lkp_geo_hier_assoc_dm -                 A5RCIHUB.BE000BM1 * 
 *                   work.Lkp_geo_hier_assoc_dm                               * 
 * Target Table:    Val_geography_dm -                      A5RCIHUB.BE000BM2 * 
 *                   work.Val_geography_dm                                    * 
 *============================================================================*/ 

%let etls_stepStartTime = %sysfunc(datetime(), datetime20.); 

/*---- Start of Pre-Process Code  ----*/ 

%di_etl_keep_work_table(Lkp_geo_hier_assoc_dm);

proc datasets lib = work nolist nowarn memtype = (data view);
   delete STG_GEOGRAPHY_X;
quit;

/*---- End of Pre-Process Code  ----*/ 

%rcSet(&syserr); 
%rcSet(&sqlrc); 

%macro etls_Validate; 

   %let runTime = %sysfunc(datetime()); 
   
   /* Create the Exception Report  */ 
   %macro makeReport; 
   
      %if (&m_excp eq 1) %then 
      %do; 
         options nodate; 
         
         proc sort data = work.etls_Exceptions; 
            by x_row; 
         run; 
         
         proc print data = work.etls_Exceptions noobs label; 
            title1 "Exceptions Found in Table: work.Lkp_geo_hier_assoc_dm"; 
            title2 "%sysfunc(datetime(),nldatmap.)"; 
         run; 
         
         options date; 
         
      %end; 
      
   %mend makeReport; 
   
   proc datasets lib = work nolist nowarn memtype = (data view);
      delete Val_geography_dm;
   quit;
   
   proc datasets lib = work nolist nowarn memtype = (data view);
      delete etls_Val_geography_dm;
   quit;    
   
   %let m_excp = 0;
   
   /*---- Begin checks for Custom, Missing Values, and Invalid Values  ----*/ 
   data work.etls_Val_geography_dm
         (keep = GEO_ID GEO_NM STD_HIER_GEO_LVL FACILITY_TYPE SIZE_OF_FACILITY 
                         OPEN_DT CLOSING_DT STREET_ADDRESS CITY STATE ZIP_CODE COUNTRY 
                         STG_STD_GEO_LVL GEO_HIER_SK DM_STD_HIER_GEO_LVL DM_CLOSE_DT
                         DM_STD_GEO_LVL ETLS_EXCEPTION_COND STD_HIER_LEAF_NODE_FLG 
                         CREATED_DTTM)
        work.etls_Errors
         (keep = GEO_ID GEO_NM STD_HIER_GEO_LVL FACILITY_TYPE SIZE_OF_FACILITY 
                         OPEN_DT CLOSING_DT STREET_ADDRESS CITY STATE ZIP_CODE COUNTRY 
                         STG_STD_GEO_LVL GEO_HIER_SK DM_STD_HIER_GEO_LVL DM_CLOSE_DT
                         DM_STD_GEO_LVL ETLS_EXCEPTION_COND STD_HIER_LEAF_NODE_FLG 
                         CREATED_DTTM)
        work.etls_Exceptions
         (keep = x_row x_column x_type x_action x_note);
   
      /* Define lengths for columns with longer lengths in target  */ 
      attrib ETLS_EXCEPTION_COND length = $&len_excp_msg1.; 
      attrib STD_HIER_LEAF_NODE_FLG length = 4; 
      attrib CREATED_DTTM length = 8
         format = NLDATM21.
         informat = NLDATM21.; 
      
      set Lkp_geo_hier_assoc_dm end=eof;
      
      attrib x_row    length = 4    label = "Row Number";
      attrib x_column length = $100 label = "Column Name";
      attrib x_type   length = $50  label = "Type of Exception";
      attrib x_action length = $50  label = "Action Taken";
      attrib x_note   length = $200 label = "Notes";
      
      retain x_note "";
      x_row = _n_;
      
      i_move = 0;
      retain i_excp &m_excp; 
      
      /*---- Custom Validation: Facility type should be in (1, 2)  ----*/ 
      if (&g_geo_low_lvl_store_flg =1 and STD_HIER_GEO_LVL = &g_max_STD_HIER_GEO_LVL and FACILITY_TYPE not in (1, 2)) then 
      do; 
         FACILITY_TYPE = 1; 
      end;  /* if (&g_geo_low_lvl_store_flg =1 and STD_HIER_GEO_LVL = &g_max_STD_HIER_GEO_LVL and FACILITY_TYPE not in (1, 2)) */
      else 
      do; 
      end;  /* else */
      
      /*---- Custom Validation: Missing Geo_nm  ----*/ 
      if (MISSING(GEO_NM)) then 
      do; 
         GEO_NM = Put(GEO_ID, $32.); 
      end;  /* if (MISSING(GEO_NM)) */
      else 
      do; 
      end;  /* else */

    
	  /*---- Custom Validation: GEO_ID change at LVL 1 NOT ALLOWED  ----*/ 
      if (&etls_recordsBefore1 gt 0 & STD_HIER_GEO_LVL= 1 & "&GEO_ID_1_LVL" ne %str("") & GEO_ID ne "&GEO_ID_1_LVL") then do; 
         ETLS_EXCEPTION_COND = cats(ETLS_EXCEPTION_COND,'0a'x,"* %etl_msg(mid=5432, args= GEO_ID)");		  
      end;


     /*---- Custom Validation: For Fac_Type=2, GEO_LVL shouldn't be populated  ----*/ 
      if (FACILITY_TYPE eq 2 and STD_HIER_GEO_LVL ne NULL ) then 
      do; 
         STD_HIER_GEO_LVL = NULL;           
      end; 

      
      /*---- Custom Validation: Std_geo_lvl should not be missing for  ----*/ 
      /*----  Facility_type ne 2                                       ----*/ 
      if (NOT MISSING(DM_STD_GEO_LVL) & STD_HIER_GEO_LVL NE DM_STD_GEO_LVL) then 
      do; 
         ETLS_EXCEPTION_COND = "%etl_msg(mid=5435, args=Std_hier_geo_lvl Geography_hier_assoc_dm)";
         i_move = 1; 
      end;  /* if (NOT MISSING(DM_STD_GEO_LVL) & STD_HIER_GEO_LVL NE DM_STD_GEO_LVL) */
      else 
      do; 
      end;  /* else */                      
           
      
      /*---- Custom Validation: Std_geo_lvl must be consistent with  ----*/ 
      /*----  stg_geo_hierarchy                                      ----*/ 
      if (NOT MISSING(STD_HIER_GEO_LVL) & NOT MISSING(STG_STD_GEO_LVL) & STD_HIER_GEO_LVL NE STG_STD_GEO_LVL) then 
      do; 
         ETLS_EXCEPTION_COND = "%etl_msg(mid=5436, args=Std_geo_lvl stg_geo_hierarchy)"; 
         i_move = 1; 
      end;  /* if (NOT MISSING(STG_STD_GEO_LVL) & STD_HIER_GEO_LVL NE STG_STD_GEO_LVL) */
      else 
      do; 
      end;  /* else */  
      
      /*---- Custom Validation: Assign Leaf Node  ----*/ 
      if (STD_HIER_GEO_LVL = input("&g_max_STD_HIER_GEO_LVL", best12.)) then 
      do; 
         STD_HIER_LEAF_NODE_FLG = 1; 
      end;  /* if (STD_HIER_GEO_LVL = input("&g_max_STD_HIER_GEO_LVL", best12.)) */
      else 
      do; 
         STD_HIER_LEAF_NODE_FLG = 0; 
      end;  /* else */
      
      /*---- Custom Validation: Std_hier_geo_lvl has changed values  ----*/ 
      if (NOT MISSING(DM_STD_HIER_GEO_LVL) & STD_HIER_GEO_LVL NE DM_STD_HIER_GEO_LVL) then 
      do; 
         ETLS_EXCEPTION_COND = cats(ETLS_EXCEPTION_COND,'0a'x,"%etl_msg(mid=5309, args=GEO_LVL)"); 
         i_move = 1; 
      end;  /* if (NOT MISSING(DM_STD_HIER_GEO_LVL) & STD_HIER_GEO_LVL NE DM_STD_HIER_GEO_LVL) */
      else 
      do; 
      end;  /* else */
      
      /*---- Custom Validation: For str_flg=0, Facility_type can be 2 or null  ----*/ 
      if (&g_geo_low_lvl_store_flg =0 and FACILITY_TYPE ne 2 and FACILITY_TYPE ne "") then 
      do; 
         FACILITY_TYPE = NULL;        
      end;  
      
      /*---- Custom Validation: Invalid GEO_LVL  ----*/ 
      if (NOT MISSING(STD_HIER_GEO_LVL ) AND STD_HIER_GEO_LVL not in (&g_valid_geo_lvls.)) then 
      do; 
         ETLS_EXCEPTION_COND = cats(ETLS_EXCEPTION_COND,'0a'x,"* %etl_msg(mid=5305,args=GEO_LVL)"); 
         i_move = 1; 
      end;  /* if (NOT MISSING(STD_HIER_GEO_LVL ) AND STD_HIER_GEO_LVL not in (&g_valid_geo_lvls.)) */
      else 
      do; 
      end;  /* else */
      
     /*---- Custom Validation: Open_dt should not be missing for lowest  ----*/ 
      /*----  geo_lvl                                                     ----*/ 
      if (MISSING(OPEN_DT) AND STD_HIER_GEO_LVL  = &g_max_STD_HIER_GEO_LVL) then 
      do; 
         ETLS_EXCEPTION_COND = cats(ETLS_EXCEPTION_COND,'0a'x,"%etl_msg(mid=5305,args=Open_dt)"); 
         i_move = 1; 
      end;  /* if (MISSING(OPEN_DT) AND STD_HIER_GEO_LVL  = &g_max_STD_HIER_GEO_LVL) */
      else 
      do; 
      end;  /* else */

     /*---- Custom Validation: Open_dt GT Closing_dt  ----*/ 
      if (OPEN_DT  gt coalesce(CLOSING_DT,  '31DEC5999'D) ) then 
      do; 
         ETLS_EXCEPTION_COND = cats(ETLS_EXCEPTION_COND,'0a'x,"%etl_msg(mid=5322,args=open_dt closing_dt)"); 
         i_move = 1; 
      end;  /* if (OPEN_DT  > coalesce(CLOSING_DT,  '31DEC5999'D) AND STD_HIER_GEO_LVL  = &g_max_std_hier_GEO_LVL) */
      else 
      do; 
      end;  /* else */

	  /*---- Custom Validation: Updation case:  Updated Open_dt GT Closing_dt  ----*/ 
      if (Not missing (DM_CLOSE_DT) and missing (CLOSING_DT) and OPEN_DT  gt DM_CLOSE_DT ) then 
      do; 
         ETLS_EXCEPTION_COND = cats(ETLS_EXCEPTION_COND,'0a'x,"%etl_msg(mid=5322,args=OPEN_DT DM.CLOSING_DT)"); 
         i_move = 1; 
      end;  /* if (OPEN_DT  > coalesce(CLOSING_DT,  '31DEC5999'D) AND STD_HIER_GEO_LVL  = &g_max_std_hier_GEO_LVL) */
      else 
      do; 
      end;  /* else */
      
      
      /*---- Custom Validation: Fac_Type can't be 1 for non-leaf node levels,  ----*/ 
      /*----  if str_flg=1                                                     ----*/ 
      if (&g_geo_low_lvl_store_flg eq 1 and FACILITY_TYPE eq 1 and STD_HIER_GEO_LVL ne &g_max_std_hier_geo_lvl) then 
      do; 
         FACILITY_TYPE = NULL; 
      end;
      
      /*---- Custom Validation: Invalid Facilty_Type  ----*/ 
      if (&g_geo_low_lvl_store_flg =1 and STD_HIER_GEO_LVL ne &g_max_STD_HIER_GEO_LVL and FACILITY_TYPE not in (1, 2) and FACILITY_TYPE ne "") then 
      do; 
         FACILITY_TYPE = NULL; 
      end;
      
      /* move record to error file  */ 
      if not missing(ETLS_EXCEPTION_COND) then 
         output work.etls_Errors;
      /* move record to output file  */ 
      else 
         output work.etls_Val_geography_dm;
         
      if eof then 
      do; 
         /* create macro flags  */ 
         call symput("m_excp", put(i_excp, 1.));
      end; 
   
   run; 
   
   %rcSet(&syserr); 
   
   %let etls_Source = work.etls_Val_geography_dm;
   
   /* add ETL_Error_JobRunTime variable to error table  */ 
   data work.etls_Errors; 
      set work.etls_Errors; 
      format ETL_Error_JobRunTime datetime16.; 
      ETL_Error_JobRunTime = "&etls_stepStartTime"dt; 
   run; 
   
   /* update the errors table  */ 
   proc append base = WORK.stg_geography_x
               data = work.etls_Errors force; 
   run; 
   
   proc datasets lib = work nolist nowarn memtype = (data view);
      delete etls_Errors;
   quit;
   
   %makeReport; 
   
   /*---- Map the columns  ----*/ 
   proc datasets lib = work nolist nowarn memtype = (data view);
      delete Val_geography_dm;
   quit;
   
   %put %str(NOTE: Mapping columns ...);
   proc sql;
      create table work.Val_geography_dm as
         select
            GEO_ID,
            GEO_NM,
            STD_HIER_GEO_LVL,
            FACILITY_TYPE,
            SIZE_OF_FACILITY,
            OPEN_DT,
            CLOSING_DT,
            STREET_ADDRESS,
            CITY,
            STATE,
            ZIP_CODE,
            COUNTRY,
            STG_STD_GEO_LVL,
            GEO_HIER_SK,
            DM_STD_HIER_GEO_LVL,
            DM_CLOSE_DT,
            DM_STD_GEO_LVL,
            ETLS_EXCEPTION_COND,
            STD_HIER_LEAF_NODE_FLG,
            (DATETIME()) as CREATED_DTTM length = 8
               format = NLDATM21.
               informat = NLDATM21.
      from work.etls_Val_geography_dm
      ;
   quit;   
   
   %goto STEP_CONTINUE;
   
   %STEP_ERR:
   
      %let sysrc = 9999; 
      %rcSet(&sysrc); 
      
   %STEP_CONTINUE:
   
   proc datasets lib = work nolist nowarn memtype = (data view);
      delete etls_Val_geography_dm;
   quit;
   
%mend etls_Validate;
%etls_Validate;

/*---- Start of Post-Process Code  ----*/ 

%let Xvarnames = %di_util_column_names(di_mon.stg_geography_x);

data stg_geography_xx;
   set Val_geography_dm;
   format ETL_Error_JobRunTime datetime16.; 
   ETL_ERROR_JOBRUNTIME = "&etls_stepStartTime"dt;
   where not missing (ETLS_EXCEPTION_COND);
run;

proc append base=stg_geography_x
            data=stg_geography_xx;
run;

proc append base=DI_MON.stg_geography_x
            data=WORK.stg_geography_x(keep=&Xvarnames);
run;

proc datasets lib = work nolist nowarn memtype = (data view);
   delete STG_GEOGRAPHY_XX;
quit;
/*---- End of Post-Process Code  ----*/ 

%rcSet(&syserr); 
%rcSet(&sqlrc); 



/**  Step end Val_geography_dm **/

/*---- Start of User Written Code  ----*/ 

%di_etl_keep_work_table(Val_geography_dm);

%etl_Scd1Loader
       (
      srctable    = work.Val_geography_dm
      ,tgttable   = DI_DM.GEOGRAPHY_DM
      ,buskey     = GEO_ID
      ,surkey     = GEO_HIER_SK
      ,rootnode_condn=%nrstr(std_hier_geo_lvl=1)
      ,change_flg = 
      ,sysopt     =
      );
/* Defect:S1247383-7611881623,7611735358 - Allow ETL to null out a Store Closing Date */
/* As per standards ETL does not allow updating Non-null values with Null values      */
/* Jcrew and Academy, need non-null Closing_dt to be updated with Null values         */
/* The update will happen only if the etlp_update_closing_dt_with_null is set to 1    */

%macro update_closing_dt;
   %if &etlp_update_closing_dt_with_null = 1 %then %do;	  
      proc sql noprint; 
         update di_dm.geography_dm set closing_dt = .
            where geo_id in (select distinct geo_id from work.val_geography_dm where closing_dt is null);
      quit;
   %end;
%mend;

%update_closing_dt;
/*---- End of User Written Code  ----*/ 

%let etls_endTime = %sysfunc(datetime(),datetime.);

/*---- Job status macro  ----*/ 
%etls_sendJobStatus(source_table = didm_stg.stg_geography);
