/* 
SUPPORT: sinass Sharma, Ashish
*/ 
/******************************************************************************
 * Job:             Load_STG2DM_Promotion_fact              A5W0V4GZ.BF0004MP *
 * Description:                                                               *
 *                                                                            *
 * Metadata Server: puneasd10.apac.sas.com                                    *
 * Port:            8561                                                      *
 * Location:        /Users/Gyan/My Folder/D2TKMI42                            *
 *                                                                            *
 * Server:          MIMain                                  A5W0V4GZ.AR000003 *
 *                                                                            *
 * Source Tables:   STG_PROMOTION - DIDM_STG.STG_PROMOTION  A5W0V4GZ.BB000BCT *
 *                  GEOGRAPHY_DM - DI_DM.GEOGRAPHY_DM       A5W0V4GZ.BB00099S *
 *                  VEHICLE_CATEGORY -                      A5W0V4GZ.BB0009KL *
 *                   DI_DM2.VEHICLE_CATEGORY                                  *
 *                  VEHICLE - DI_DM2.VEHICLE                A5W0V4GZ.BB0009KK *
 *                  PRODUCT_DM - DI_DM.PRODUCT_DM           A5W0V4GZ.BB0009CJ *
 *                                                                            *
 * Generated on:    Wednesday, June 30, 2010 3:57:15 PM IST                   *
 * Generated by:    singyg@row                                                *
 * Version:         SAS Data Integration Studio 4.2                           *
 ******************************************************************************/

/* General macro variables  */
%let jobID = %quote(A5W0V4GZ.BF0004MP);
%let etls_jobName = %nrquote(LOAD_STG2DM_PROMOTION_FACT);
%let etls_userID = %nrquote(singyg@row);

/* Setup to capture return codes  */
%global job_rc trans_rc sqlrc;
%let sysrc = 0;
%let job_rc = 0;
%let trans_rc = 0;
%let sqlrc = 0;
%global syserr;
options minoperator;

%macro rcSet(error);
   %if (&error gt &trans_rc) %then
      %let trans_rc = &error;
   %if (&error gt &job_rc) %then
      %let job_rc = &error;
%mend rcSet;

%macro rcSetDS(error);
   if &error gt input(symget('trans_rc'),12.) then
      call symput('trans_rc',trim(left(put(&error,12.))));
   if &error gt input(symget('job_rc'),12.) then
      call symput('job_rc',trim(left(put(&error,12.))));
%mend rcSetDS;

/* Create metadata macro variables */
%let IOMServer      = %nrquote(MIMain);

/* Setup for capturing job status  */
%let etls_startTime = %sysfunc(datetime(),datetime.);
%let etls_init_startTime = &etls_startTime;
%let etls_recordsBefore = 0;
%let etls_recordsAfter = 0;
%let etl_xobsbefore_tgt = %di_util_nobs(DI_MON.STG_PROMOTION_X);
%let etls_lib = 0;
%let etls_table = 0;


%global etls_debug;
%macro etls_setDebug;
   %if %str(&etls_debug) ne 0 %then
      OPTIONS MPRINT%str(;);
%mend;
%etls_setDebug;

/*---- Start of Pre-Process Code  ----*/

%etl_initjobparam (monlib=di_mon, jobname=%nrquote(&etls_jobName));
/**/
%etl_initchangeflags;
/*---- End of Pre-Process Code  ----*/


%di_etl_rcset(error=&syserr,code=job_rc);

/*---- Start of User Written Code  ----*/

/*============================================================================*
 * Step:            Uw_PreProcess                           A5W0V4GZ.BH000EZO *
 * Transform:       User Written                                              *
 * Description:                                                               *
 *                                                                            *
 * Source Table:    STG_PROMOTION - DIDM_STG.STG_PROMOTION  A5W0V4GZ.BB00097D *
 * Target Table:    Uw_PreProcess - DIDM_STG.STG_PROMOTION  A5W0V4GZ.BK000C82 *
 *                                                                            *
 * User Written:    SourceCode                                                *
 *============================================================================*/

%macro etl_pre_process;
   %global etl_promo_prod_lvl
           etl_promo_geo_lvl
           etl_partition_level
           etl_current_record_window
           num_parallel_executions
           etl_current_date_sk
           price_hist_weeks_keep
           pos_hist_weeks_keep
           g_curr_date_sk
           g_curr_wk;
   %local  etl_abort;
   %let    etl_abort=0;

   /***********************************************************************/
   /*get prod/geo level parameters and current date sk from global_setting*/
   /**********************************************************************/
   %di_util_global_setting_spec(spec_nm=PROMO_PROD_LVL,
                                app=ALL,
                                _spec_value=etl_promo_prod_lvl,
                                optional=0);

   %di_util_global_setting_spec(spec_nm=PROMO_GEO_LVL,
                                app=ALL,
                                _spec_value=etl_promo_geo_lvl,
                                optional=0);

   %di_util_global_setting_spec(spec_nm=PROD_PARTITION_LVL,
                                app=ALL,
                                _spec_value=etl_partition_level,
                                optional=0);

   %di_util_global_setting_spec(spec_nm=NUM_PARALLEL_EXECUTIONS,
                                app=ALL,
                                _spec_value=num_parallel_executions,
                                optional=1);

   %di_util_global_setting_spec(spec_nm=CURRENT_DATE_SK,
                                app=ALL,
                                _spec_value=etl_current_date_sk,
                                optional=0);

   %if %symexist(etlp_condtn_promo_veh_ctgrs) %then
   %do;
   %end;
   %else
   %do;
      %let etl_msg = %etl_msg(mid=5012,args=ETLP_CONDTN_PROMO_VEH_CTGRS JOB_PARAM);
      %put &etl_msg;
      %let etl_abort = 1 ;
   %end;

   %if ( &etl_promo_prod_lvl eq %str() or &etl_promo_prod_lvl eq %str(.)) %then
   %do;
      %let etl_msg = %etl_msg(mid=5012,args=PROMO_PROD_LVL GLOBAL_SETTING);
      %put &etl_msg;
      %let etl_abort = 2 ;
   %end;

   %if ( &etl_promo_geo_lvl eq %str() or &etl_promo_geo_lvl eq %str(.)) %then
   %do;
      %let etl_msg = %etl_msg(mid=5012,args=PROMO_GEO_LVL GLOBAL_SETTING);
      %put &etl_msg;
      %let etl_abort = 3 ;
   %end;

   %if ( &etl_partition_level eq %str() or &etl_partition_level eq %str(.)) %then
   %do;
      %let etl_msg = %etl_msg(mid=5012,args=PROD_PARTITION_LVL GLOBAL_SETTING);
      %put &etl_msg;
      %let etl_abort = 4 ;
   %end;

   %if ( &etl_current_date_sk eq %str() or &etl_current_date_sk eq %str(.)) %then
   %do;
      %let etl_msg = %etl_msg(mid=5012,args=CURRENT_DATE_SK GLOBAL_SETTING);
      %put &etl_msg;
      %let etl_abort = 5 ;
   %end;

   %if &etl_abort > 0 %then %etl_abort;

   %put PROMO_PROD_LVL=&etl_promo_prod_lvl;
   %put PROMO_GEO_LVL=&etl_promo_geo_lvl;
   %put PARTITION LEVEL=&etl_partition_level;
   %put CURRENT_DATE_SK=&etl_current_date_sk;

   %if &num_parallel_executions =%str() %then %do;
      %let num_parallel_executions = 8;
   %end;

   %put NUM_PARALLEL_EXECUTIONS=&num_parallel_executions;

   /*******************************************************/
   /****Check for existence of DI_DM.PRODUCT_DM dataset****/
   /*******************************************************/

   %if NOT %sysfunc(exist(DI_DM.PRODUCT_DM)) %then
   %do;
      %let etl_msg = %etl_msg(mid=5005,args=DI_DM.PRODUCT_DM);
      %put &etl_msg;
      %let etl_abort=6;
   %end;

   %else %do;
      %let product_dm_obs = %di_util_nobs(DI_DM.PRODUCT_DM);
      %if &product_dm_obs = 0 %then
      %do;
          %let etl_msg = %etl_msg(mid=5008,args=DI_DM.PRODUCT_DM);
          %put &etl_msg;
      %end;
   %end;

   %di_etl_rcset(error=&syserr,code=job_rc);

   /*****************************************************************/
   /****Check for existence of DI_DM.PRODUCT_HIER_ASSOC_DM dataset***/
   /*****************************************************************/

   %if NOT %sysfunc(exist(DI_DM.PRODUCT_HIER_ASSOC_DM)) %then
   %do;
      %let etl_msg = %etl_msg(mid=5005,args=DI_DM.PRODUCT_HIER_ASSOC_DM);
      %put &etl_msg;
      %let etl_abort=7;
   %end;
   %else %do;
      %let product_hier_assoc_obs = %di_util_nobs(DI_DM.PRODUCT_HIER_ASSOC_DM);
      %if &product_hier_assoc_obs = 0 %then
      %do;
         %let etl_msg = %etl_msg(mid=5008,args=DI_DM.PRODUCT_HIER_ASSOC_DM);
         %put &etl_msg;
      %end;
   %end;

   %di_etl_rcset(error=&syserr,code=job_rc);

   /*******************************************************/
   /****Check for existence of DI_DM.PRODUCT_LVL dataset***/
   /*******************************************************/

   %if NOT %sysfunc(exist(DI_DM.PRODUCT_LVL)) %then
   %do;
      %let etl_msg = %etl_msg(mid=5005,args=DI_DM.PRODUCT_LVL);
      %put &etl_msg;
      %let etl_abort=8;
   %end;
   %else %do;
      %let product_lvl_obs = %di_util_nobs(DI_DM.PRODUCT_LVL);
      %if &product_lvl_obs = 0 %then
      %do;
         %let etl_msg = %etl_msg(mid=5008,args=DI_DM.PRODUCT_LVL);
         %put &etl_msg;
      %end;
   %end;

   %di_etl_rcset(error=&syserr,code=job_rc);

   /*******************************************************/
   /***Check for existence of DI_DM.GEOGRAPHY_DM dataset***/
   /*******************************************************/

   %if NOT %sysfunc(exist(DI_DM.GEOGRAPHY_DM)) %then
   %do;
      %let etl_msg = %etl_msg(mid=5005,args=DI_DM.GEOGRAPHY_DM);
      %put &etl_msg;
      %let etl_abort=9;
   %end;

   %else %do;
      %let geography_dm_obs = %di_util_nobs(DI_DM.GEOGRAPHY_DM);
      %if &geography_dm_obs = 0 %then
      %do;
         %let etl_msg = %etl_msg(mid=5008,args=DI_DM.GEOGRAPHY_DM);
         %put &etl_msg;
      %end;
   %end;

   %di_etl_rcset(error=&syserr,code=job_rc);

   /*******************************************************/
   /***Check for existence of DI_DM.GEOGRAPHY_LVL dataset**/
   /*******************************************************/

   %if NOT %sysfunc(exist(DI_DM.GEOGRAPHY_LVL)) %then
   %do;
      %let etl_msg = %etl_msg(mid=5005,args=DI_DM.GEOGRAPHY_LVL);
      %put &etl_msg;
      %let etl_abort=10;
   %end;
   %else %do;
      %let geography_lvl_obs = %di_util_nobs(DI_DM.GEOGRAPHY_LVL);
      %if &geography_lvl_obs = 0 %then
      %do;
         %let etl_msg = %etl_msg(mid=5008,args=DI_DM.GEOGRAPHY_LVL);
         %put &etl_msg;
      %end;
   %end;

   %di_etl_rcset(error=&syserr,code=job_rc);

   /*******************************************************/
   /*****Check for existence of DI_DM2.VEHICLE dataset*****/
   /*******************************************************/

   %if NOT %sysfunc(exist(DI_DM2.VEHICLE)) %then
   %do;
      %let etl_msg = %etl_msg(mid=5005,args=DI_DM2.VEHICLE);
      %put &etl_msg;
      %let etl_abort=11;
   %end;

   %di_etl_rcset(error=&syserr,code=job_rc);

   /****************************************************************/
   /*****Check for existence of DI_DM2.VEHICLE_CATEGORY dataset*****/
   /****************************************************************/

   %if NOT %sysfunc(exist(DI_DM2.VEHICLE_CATEGORY)) %then
   %do;
      %let etl_msg = %etl_msg(mid=5005,args=DI_DM2.VEHICLE_CATEGORY);
      %put &etl_msg;
      %let etl_abort=12;
   %end;
   %else %do;
      proc sql noprint;
          select count(*) into :veh_cat_obs
          from DI_DM2.VEHICLE_CATEGORY;
      quit;
      %if &veh_cat_obs = 0 %then
      %do;
         %let etl_msg = %etl_msg(mid=5008,args=DI_DM2.VEHICLE_CATEGORY);
         %put &etl_msg;
      %end;
   %end;

   %di_etl_rcset(error=&syserr,code=job_rc);

   %if &etl_abort gt 0 %then %etl_abort;

   /**************************************************************************/
   /* Retrieving current date, history date and POS hist date                */
   /**************************************************************************/
   proc sql noprint;
     select put(fiscal_start_dt,best.)
       into :g_curr_wk
       from di_dm.date_dm
      where date_sk = &etl_current_date_sk;
   quit;

   proc sql noprint;
     select put(fiscal_start_dt, best.)
       into :price_hist_weeks_keep
       from di_dm.date_dm
      where date_sk = (&etl_current_date_sk - &etlp_price_hist_weeks_keep);
   quit;
   
   %if &etlp_pos_enable ne 0 %then %do;
      proc sql noprint;
        select put(fiscal_start_dt, best.)
        into :pos_hist_weeks_keep
        from di_dm.date_dm
        where date_sk = (&etl_current_date_sk - &etlp_pos_hist_weeks_keep);
      quit;

      %put records retention window for pos vehicle   = &pos_hist_weeks_keep;
   %end;
   
   %put start date of fiscal weeek = &g_curr_wk;
   %put records retention window for price vehicle = &price_hist_weeks_keep;
   

   %if NOT %symexist(etl_delete_flg) %then %do;
     %put NOTE: delete flag not initialized in translation values;
      %global etl_delete_flg;
      %let etl_delete_flg = D;
   %end;

   %di_etl_rcset(error=&syserr,code=job_rc);

%mend etl_pre_process;

%etl_pre_process;

%di_etl_rcset(error=&syserr,code=job_rc);

/*******************************************/
/* creating temporary library inside WORK  */
/*******************************************/
%di_etl_set_lib(parent_lib=WORK, sub_folder=../promo_err, partition_lib=MON_PRM);
/*---- End of User Written Code  ----*/

/*---- Start of User Written Code  ----*/

/*============================================================================*
 * Step:            Uw_extract_Veh_cat                      A5W0V4GZ.BH0009F1 *
 * Transform:       User Written                                              *
 * Description:                                                               *
 *                                                                            *
 * Source Table:    VEHICLE_CATEGORY -                      A5W0V4GZ.BB0003KL *
 *                   DI_DM2.VEHICLE_CATEGORY                                  *
 * Target Table:    Uw_extract_Veh_cat -                    A5W0V4GZ.BK0007MQ *
 *                   work.Uw_extract_Veh_cat                                  *
 *                                                                            *
 * User Written:    SourceCode                                                *
 *============================================================================*/

%di_dm_trans_extract(
   di_trans      = di_dm2,
   trans_table   = VEHICLE_CATEGORY,
   all_trans     = 0,
   select_list   = %str(VEHICLE_CATEGORY_SK,VEHICLE_CATEGORY_NM,VEHICLE_CATEGORY_TYPE),
   _output_table = MON_PRM.vehicle_category
   );

%di_etl_rcset(error=&syserr,code=job_rc);

proc sql;
   create unique index VEHICLE_CATEGORY_SK on MON_PRM.vehicle_category;
quit;

/*---- End of User Written Code  ----*/

/*---- Start of User Written Code  ----*/

/*============================================================================*
 * Step:            User Written                            A5W0V4GZ.$0001154 *
 * Transform:       User Written                                              *
 * Description:                                                               *
 *                                                                            *
 * Target Table:    User Written - MON_PRM.Vehicle          A5W0V4GZ.$0001156 * 
 *                                                                            *
 * User Written:    SourceCode                                                *
 *============================================================================*/

%di_dm_trans_extract(
   di_trans=di_dm2,
   trans_table=VEHICLE,
   all_trans=0,
   _output_table=MON_PRM.Vehicle,
   select_list=%str(VEHICLE_SK ,VEHICLE_NM),
   filter_cond=%str(VEHICLE_GROUP_SK is null)
   );

%di_etl_rcset(error=&syserr,code=job_rc);

proc sql;
   create unique index VEHICLE_SK on MON_PRM.Vehicle;
quit;

/*---- End of User Written Code  ----*/

/*---- Start of User Written Code  ----*/

/*============================================================================*
 * Step:            User Written                            A5W0V4GZ.$0002755 *
 * Transform:       User Written                                              *
 * Description:                                                               *
 *                                                                            *
 * Source Table:    PRODUCT_DM - DI_DM.PRODUCT_DM           A5W0V4GZ.BB0003CR *
 * Target Table:    User Written - work.product_dm          A5W0V4GZ.$0002757 *
 *                                                                            *
 * User Written:    SourceCode                                                *
 *============================================================================*/

proc sql;
   create table product_dm as 
     select prod_id length=32, 
            max(prod_hier_sk) as prod_hier_sk length=6, 
            std_hier_prod_lvl
       from di_dm.product_dm
   group by prod_id, std_hier_prod_lvl;
quit;

%di_etl_rcset(error=&syserr,code=job_rc);

/*---- End of User Written Code  ----*/

/*============================================================================*
 * Step:            Lkp_valid_data                                            * 
 * Transform:       Lookup                                                    * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Tables:   Uw_PreProcess - DIDM_STG.STG_PROMOTION                    * 
 * Lookup tables    DI_DM.GEOGRAPHY_DM                                        *             
 *                  work.product_dm                                           * 
 *                  work.vehicle_category                                     * 
 *                  MON_PRM.Vehicle                                           * 
 *                  work.prod_partition_map                                   * 
 * Target Table:    Lkp_valid_data - work.Uw_valid_data1                      * 
 *============================================================================*/

%let transformID = %quote(A5W0V4GZ.BH000MTF);
%let trans_rc = 0;
%let etls_stepStartTime = %sysfunc(datetime(), datetime20.); 

%let runTime = %sysfunc(datetime()); 

proc datasets lib = work nolist nowarn memtype = (data view);
   delete Uw_valid_data1 Uw_valid_data2 temp_promotion_x prod_partition_map;
quit;

proc sql; 
    create table work.prod_partition_map as 
    select PROD_HIER_SK,
           PARENT_PROD_HIER_SK as PART_SK
    from DI_DM.PRODUCT_HIER_ASSOC_DM
    where PROD_HIER_ASSOC_CD =1 
    and PARENT_PROD_LVL = &etl_partition_level;
quit;

%macro uw_promo_data_validation;
   
   /*---- Begin DATA step to perform lookups and validation  ----*/ 
   DATA work.Uw_valid_data1(keep = START_DT END_DT PRICE_VALUE CHANGE_FLG GEO_HIER_SK PROD_HIER_SK VEHICLE_CATEGORY_SK VEHICLE_SK 
                                   CONDITION_TYPE RANGE_START_DISC_PCT RANGE_END_DISC_PCT PART_SK)

        work.Uw_valid_data2(keep = START_DT END_DT PRICE_VALUE CHANGE_FLG GEO_HIER_SK PROD_HIER_SK VEHICLE_CATEGORY_SK VEHICLE_SK 
                                   CONDITION_TYPE RANGE_START_DISC_PCT RANGE_END_DISC_PCT)

        work.temp_promotion_x (keep = GEO_ID PROD_ID START_DT VEHICLE_NM END_DT VEHICLE_CATEGORY_NM PRICE_VALUE CHANGE_FLG 
                    CONDITION_TYPE RANGE_START_DISC_PCT RANGE_END_DISC_PCT ETLS_EXCEPTION_COND ETL_Error_JobRunTime)
        ;

      attrib ETLS_EXCEPTION_COND length=$350
             GEO_ID length=$32
             PROD_ID length=$32
             START_DT length=8 format=DATE9.
             VEHICLE_NM length=$100
             END_DT length=8 format=DATE9.
             VEHICLE_CATEGORY_NM length=$100
             PRICE_VALUE length=8 format=NLNUM20.3
             CHANGE_FLG length=$1
             GEO_HIER_SK length=4
             PROD_HIER_SK length=6
             STD_HIER_PROD_LVL length=4
             VEHICLE_CATEGORY_SK length=6
             VEHICLE_SK length=6 format=11.
             CONDITION_TYPE length=4
             RANGE_START_DISC_PCT length=8 format=NLNUM12.4
             RANGE_END_DISC_PCT length=8 format=NLNUM12.4
             STD_HIER_GEO_LVL length= 4
             PART_SK length=6
             ETL_Error_JobRunTime length = 8
             ; 

      retain missing0-missing4 0; 

      /* Build hash objects from lookup tables before reading first source row  */ 
      if (_n_ = 1) then 
      do; 


         /* Build hash h0 from lookup table DI_DM.GEOGRAPHY_DM */
         %di_util_hash_define( h_num = 0,
                               dsn   = %QUOTE(DI_DM.GEOGRAPHY_DM),
                               d_key = %QUOTE("GEO_ID"),
                               d_data= %QUOTE("GEO_HIER_SK","STD_HIER_GEO_LVL")
                               );

         /* Build hash h1 from lookup table work.product_dm */ 
         %di_util_hash_define( h_num = 1,
                               dsn   = %QUOTE(work.product_dm),
                               d_key = %QUOTE("PROD_ID"),
                               d_data= %QUOTE("PROD_HIER_SK", "STD_HIER_PROD_LVL")
                               );

         /* Build hash h2 from lookup table MON_PRM.vehicle_category */ 
         %di_util_hash_define( h_num = 2,
                               dsn   = %QUOTE(MON_PRM.vehicle_category),
                               d_key = %QUOTE("VEHICLE_CATEGORY_NM"),
                               d_data= %QUOTE("VEHICLE_CATEGORY_SK")
                               );

         /* Build hash h3 from lookup table MON_PRM.Vehicle */ 
         %di_util_hash_define( h_num = 3,
                               dsn   = %QUOTE(MON_PRM.Vehicle),
                               d_key = %QUOTE("VEHICLE_NM"),
                               d_data= %QUOTE("VEHICLE_SK")
                               );

         /* Build hash h4 from lookup table work.prod_partition_map */ 
         %di_util_hash_define( h_num = 4,
                               dsn   = %QUOTE(work.prod_partition_map),
                               d_key = %QUOTE("PROD_HIER_SK"),
                               d_data= %QUOTE("PART_SK")
                               );

         call missing (GEO_ID, GEO_HIER_SK, STD_HIER_GEO_LVL, PROD_ID, PROD_HIER_SK, 
                       STD_HIER_PROD_LVL, VEHICLE_CATEGORY_NM, VEHICLE_CATEGORY_SK, 
                       VEHICLE_NM, VEHICLE_SK, PART_SK); 

      end; /* All hash objects have been defined */

      /* Read a row from the source table  */ 
      set DIDM_STG.STG_PROMOTION end = eof;

      /* Is the current key value stored in hash h0?  */ 
      if (missing0 < 1) then 
      do; 
         rc0 = h0.find();
      end; 
      else 
         rc0 = missing0; 

      /* Is the current key value stored in hash h1?  */ 
      if (missing1 < 1) then 
      do; 
         rc1 = h1.find();
      end; 
      else 
         rc1 = missing1; 

      /* Is the current key value stored in hash h2?  */ 
      if (missing2 < 1) then 
      do; 
         rc2 = h2.find();
      end; 
      else 
         rc2 = missing2; 

      /* Is the current key value stored in hash h3?  */ 
      if (missing3 < 1) then 
      do; 
         rc3 = h3.find();
      end; 
      else 
         rc3 = missing3; 

      /* Examine success of lookups  */
      if (rc0 ^= 0) then do;
         call missing (GEO_HIER_SK, STD_HIER_GEO_LVL);
         ETLS_EXCEPTION_COND = put(cats(ETLS_EXCEPTION_COND,'0a'x,"%etl_msg(mid=5305,args=Geo_ID)"),$350.);
      end;
      
      if (rc1 ^= 0) then do;
         call missing (PROD_HIER_SK, STD_HIER_PROD_LVL);
         ETLS_EXCEPTION_COND = put(cats(ETLS_EXCEPTION_COND,'0a'x,"%etl_msg(mid=5305,args=Prod_ID)"),$350.);
      end;
      
      if (rc2 ^= 0) then do;
         call missing (VEHICLE_CATEGORY_SK);
         ETLS_EXCEPTION_COND = put(cats(ETLS_EXCEPTION_COND,'0a'x,"%etl_msg(mid=5305,args=vehicle_category_nm)"),$350.);
      end;
      
      if (rc3 ^= 0) then do;
         call missing (VEHICLE_SK);
      end;

      if VEHICLE_CATEGORY_SK gt 99 and VEHICLE_SK eq . then
         ETLS_EXCEPTION_COND = put(cats(ETLS_EXCEPTION_COND,'0a'x,"%etl_msg(mid=5305,args=vehicle_nm)"),$350.);
         
      if (missing(VEHICLE_SK) or  VEHICLE_SK < 100) and VEHICLE_CATEGORY_SK < 100 then 
         VEHICLE_SK = VEHICLE_CATEGORY_SK;

      %if &etl_promo_prod_lvl ne 0 %then %do;
      if PROD_HIER_SK ne . and STD_HIER_PROD_LVL not in (&etl_promo_prod_lvl) then
         ETLS_EXCEPTION_COND = put(cats(ETLS_EXCEPTION_COND,'0a'x,"%etl_msg(mid=5305,args=Prod_LVL)"),$350.);
      %end;
      
      %if &etl_promo_geo_lvl ne 0 %then %do;
      if GEO_HIER_SK ne . and STD_HIER_GEO_LVL not in (&etl_promo_geo_lvl) then 
         ETLS_EXCEPTION_COND = put(cats(ETLS_EXCEPTION_COND,'0a'x,"%etl_msg(mid=5305,args=Geo_LVL)"),$350.);
      %end;
      
      if start_dt > end_dt then
         ETLS_EXCEPTION_COND = put(cats(ETLS_EXCEPTION_COND,'0a'x,"%etl_msg(mid=5328,args=end_dt start_dt)"),$350.);

      if VEHICLE_CATEGORY_SK in (51,52,53,54) then PRICE_VALUE = 0;
 
      if VEHICLE_CATEGORY_SK < = 99 and VEHICLE_CATEGORY_SK not in (0,1,3,11,13) and (PRICE_VALUE = . or  PRICE_VALUE < 0 or PRICE_VALUE >100) then
         ETLS_EXCEPTION_COND = put(cats(ETLS_EXCEPTION_COND,'0a'x,"%etl_msg(mid=5379)"),$350.);

      if VEHICLE_CATEGORY_SK in (0,1,3,11,13) and (PRICE_VALUE = . or  PRICE_VALUE < 0 ) then
         ETLS_EXCEPTION_COND = put(cats(ETLS_EXCEPTION_COND,'0a'x,"%etl_msg(mid=5305,args=Price_value)"),$350.);

      /* imputation in case of missing CONDITION_TYPE/RANGE_START_DISC_PCT/RANGE_START_DISC_PCT*/
      if CONDITION_TYPE  = . then CONDITION_TYPE  = 0;
      
      if CONDITION_TYPE  not in (0,1,2) then
         ETLS_EXCEPTION_COND = put(cats(ETLS_EXCEPTION_COND,'0a'x,"%etl_msg(mid=5380)"),$350.);

      if CONDITION_TYPE  = 0 then do;
         RANGE_START_DISC_PCT = 0;
         RANGE_END_DISC_PCT   = 100;
      end;
      else if CONDITION_TYPE  = 1 then do;
         RANGE_START_DISC_PCT = 0;
         RANGE_END_DISC_PCT   = .01;
      end;
      else if CONDITION_TYPE  = 2 then do;
         if RANGE_START_DISC_PCT = . then RANGE_START_DISC_PCT = 0.01;
         if RANGE_END_DISC_PCT = . then RANGE_END_DISC_PCT   = 100;
         if RANGE_START_DISC_PCT > RANGE_END_DISC_PCT then
            ETLS_EXCEPTION_COND = put(cats(ETLS_EXCEPTION_COND,'0a'x,"%etl_msg(mid=5328,args=RANGE_END_DISC_PCT RANGE_START_DISC_PCT)"),$350.);
         /* validation to check valid ranges for RANGE_START_DISC_PCT/RANGE_START_DISC_PCT*/

         if RANGE_START_DISC_PCT < 0.01 then
            ETLS_EXCEPTION_COND = put(cats(ETLS_EXCEPTION_COND,'0a'x,"%etl_msg(mid=5327,args=RANGE_START_DISC_PCT CONDITION_TYPE=2 )"),$350.);
         if RANGE_END_DISC_PCT > 100 then
            ETLS_EXCEPTION_COND = put(cats(ETLS_EXCEPTION_COND,'0a'x,"%etl_msg(mid=5327,args=RANGE_END_DISC_PCT CONDITION_TYPE=2 )"),$350.);
      end;
      
      /* validation to filter out historical records */

      if (end_dt < &g_curr_wk) and CONDITION_TYPE > 0 then 
         ETLS_EXCEPTION_COND = put(cats(ETLS_EXCEPTION_COND,'0a'x,"%etl_msg(mid=5381)"),$350.);

      if (end_dt < &price_hist_weeks_keep) and (VEHICLE_CATEGORY_SK in (1,2,3)) and  CONDITION_TYPE = 0 then 
          ETLS_EXCEPTION_COND = put(cats(ETLS_EXCEPTION_COND,'0a'x,"%etl_msg(mid=5378)"),$350.);

      %if &etlp_pos_enable eq 0 %then %do;
         if VEHICLE_CATEGORY_SK in (11,12,13) then 
            ETLS_EXCEPTION_COND = put(cats(ETLS_EXCEPTION_COND,'0a'x,"%etl_msg(mid=5305,args=VEHICLE_CATEGORY_NM)"),$350.);
      %end;

      %if %eval(%length(%trim("&etlp_condtn_promo_veh_ctgrs")) > 0) %then %do;
         If condition_type > 0 and vehicle_category_sk not in (&etlp_condtn_promo_veh_ctgrs) then
            ETLS_EXCEPTION_COND = put(cats(ETLS_EXCEPTION_COND,'0a'x,"%etl_msg(mid=5341,args=VEHICLE_CATEGORY_SK ETLP_CONDTN_PROMO_VEH_CTGRS)"),$350.);
      %end;
      ETL_Error_JobRunTime = "&etls_startTime"dt;
      
      if not missing(ETLS_EXCEPTION_COND) then do;
         output work.temp_promotion_x;
      end;   
      else if STD_HIER_PROD_LVL < &etl_partition_level then do;
         output Uw_valid_data2;
      end;   
      else do;
      
         /* Check if the product belongs to a valid partition */
         if (missing4 < 1) then 
         do; 
            rc4 = h4.find();
         end; 
         else 
            rc4 = missing4;
            
         if rc4 eq 0 then 
            output Uw_valid_data1;
         else do;
            ETLS_EXCEPTION_COND = put(cats(ETLS_EXCEPTION_COND,'0a'x,"%etl_msg(mid=5306,args=PARENT_PROD[Partition-lvl])"),$350.);
            output temp_promotion_x;
         end;
         
      end;

   run;
   
   %di_etl_rcset(error=&syscc,code=job_rc);
   /* save exceptions */
   proc append force
       base=di_mon.stg_promotion_x
       data=work.temp_promotion_x;
   run;

   %di_etl_rcset(error=&syserr,code=job_rc);

   /****************************************************/
   /* Data Disaggregation */
   /****************************************************/

   %let no_of_high_data = %di_util_nobs(Uw_valid_data2);
   %put no_of_high_data = &no_of_high_data;
   %if &no_of_high_data > 0 %then %do;

      proc datasets lib=work nolist nowarn memtype = (data view);
         delete prod_hier_high_sgl;
      quit;

      proc sql; 
         create table work.prod_hier_high_sgl as 
         select b.START_DT,
                b.END_DT,
                b.PRICE_VALUE,
                b.CHANGE_FLG,
                b.GEO_HIER_SK,
                a.PROD_HIER_SK,
                a.PROD_HIER_SK as PART_SK,
                b.VEHICLE_CATEGORY_SK,
                b.VEHICLE_SK,
                b.RANGE_START_DISC_PCT,
                b.RANGE_END_DISC_PCT,
                b.CONDITION_TYPE
           from DI_DM.PRODUCT_HIER_ASSOC_DM a,
                work.UW_VALID_DATA2 b
         where a.PROD_HIER_ASSOC_CD =1 
           and a.PROD_LVL = &etl_partition_level
           and a.PARENT_PROD_HIER_SK = b.PROD_HIER_SK
          ;
     quit;

      %di_etl_rcset(error=&syserr,code=job_rc);

      proc append data = prod_hier_high_sgl base = Uw_valid_data1 force;
      run;

      %di_etl_rcset(error=&syserr,code=job_rc);

   %end;

   proc datasets lib=work nolist nowarn memtype = (data view);
      delete sorted_valid_data;
   quit;

   /****************************************************/
   /*   Appending duplicate records to error table     */
   /****************************************************/
   proc sort data=Uw_valid_data1
             out=work.sorted_valid_data
             nodupkey 
             dupout=work.promo_dups;
      by part_sk prod_hier_sk geo_hier_sk Vehicle_sk condition_type range_start_disc_pct range_end_disc_pct start_dt;
   run;

   %if %di_util_nobs(work.promo_dups) > 0 %then %do;
      proc sql;
         create table work.promo_dups_with_id(keep=%di_util_column_names(di_mon.stg_promotion_x)) as
         select p.prod_id length=32,
                g.geo_id length=32,
                v.vehicle_nm,
                e.start_dt,
                e.end_dt,
                e.condition_type,
                e.range_start_disc_pct,
                e.range_end_disc_pct,
                vc.vehicle_category_nm,
                e.price_value,
                e.change_flg,
                "%etl_msg(mid=5351)" as etls_exception_cond length=350,
                "&etls_startTime"dt as ETL_Error_JobRunTime length=8
           from work.promo_dups e
          inner join di_dm.product_dm p on (e.prod_hier_sk = p.prod_hier_sk)
          inner join di_dm.geography_dm g on (e.geo_hier_sk = g.geo_hier_sk)
          inner join MON_PRM.vehicle_category vc on (e.vehicle_category_sk = vc.vehicle_category_sk)
           left join MON_PRM.Vehicle v on (e.vehicle_sk = v.vehicle_sk);
      quit;

      %di_etl_rcset(error=&syserr,code=job_rc);
      
      /* save exceptions */
      proc append force
          base=di_mon.stg_promotion_x
          data=work.promo_dups_with_id(keep=%di_util_column_names(di_mon.stg_promotion_x)) ;
      run;

      %di_etl_rcset(error=&syscc,code=job_rc);
   %end;

   proc datasets lib=work nolist nowarn memtype = (data view);
      delete Promo_dups promo_dup1 Temp_promotion_x Uw_valid_data1 Uw_valid_data2;
   quit;

   %di_etl_rcset(error=&syserr,code=job_rc);

%mend uw_promo_data_validation;

%uw_promo_data_validation;

%di_etl_rcset(error=&syserr,code=job_rc);

%di_etl_keep_work_table(sorted_valid_data prod_partition_map);
/****************************************/
/* creating template for each partition */
/****************************************/
%di_etl_create_empty_part_dataset(table = PROMOTION_FACT);

%macro load_promotion_chk;

   %local t_subset_list list_part_sk num_parts_sk iter out_table tmp_part;

   /* Creating the MPConnect argument table */
   proc datasets lib=MON_PRM nolist nowarn memtype = (data view);
      delete mpconn_arg_promo;
   quit;   
   
   proc sql; 
      create table MON_PRM.mpconn_arg_promo as 
      select distinct(PART_SK),
             'PROMOTION_FACT' as fact_table 
        from work.prod_partition_map;
   quit;

   %di_etl_rcset(error=&syserr,code=job_rc);
   /* Splitting the valid stage records into different partitions by part_sk */

   proc sql noprint;
      select strip(put(part_sk,20.)), 
             count(part_sk),
             cats("MON_PRM.STG_PROMOTION_",strip(put(part_sk,20.)))
       into  :list_part_sk separated by ' ', 
             :num_parts_sk,
             :t_subset_list separated by ' '
        from MON_PRM.mpconn_arg_promo;
   quit;

   /* MON_PRM.STG_PROMOTION_<PART_SK> is created as partitioned stage table   */

   data &t_subset_list;
      set work.sorted_valid_data;
      %do iter=1 %to &num_parts_sk; 
         %let tmp_part = %scan(&list_part_sk,&iter,%str( ));
         %let out_table = %sysfunc(cats(MON_PRM.STG_PROMOTION_&tmp_part));
         %if &iter=1 %then %do;
            if part_sk eq &tmp_part then do;
               output &out_table;
            end;
         %end;
         %else %do;
            else if part_sk eq &tmp_part then do;
               output &out_table;
            end;
         %end;
      %end; 
      drop part_sk;
   run;

   %di_etl_rcset(error=&syserr,code=job_rc);

   %let etls_recordsBefore_tgt = %di_util_nobs(DI_DM.PROMOTION_FACT);

   %di_etl_rcset(error=&syserr,code=job_rc);

   proc datasets lib=work kill memtype=(data view); run; quit;
   
   %di_util_mp_connect(mac_name=di_etl_update_promotion_fact,arg_table=MON_PRM.mpconn_arg_promo,
                       nm_prll_exec=&num_parallel_executions,wait_interval=5,prefix=%str(promotion_fact));

   /*************************************************************************************/


   %let etl_xobsbefore = &etl_xobsbefore_tgt;
   %let etls_recordsBefore = %di_util_nobs(DI_DM.PROMOTION_FACT);
   %let etls_recordsafter = %di_util_nobs(DI_DM.PROMOTION_FACT);
   %let etls_table = PROMOTION_FACT;
   %let etls_lib   =DI_DM;
   %let etls_endTime = %sysfunc(datetime(),datetime.);
   %let etlp_exception_table=di_mon.stg_promotion_x;



   %if NOT %sysfunc(exist(MON_PRM.job_status)) %then
   %do;
      %etls_sendJobStatus(source_table = didm_stg.stg_promotion,dataset=DI_MON.job_status);
   %end;
   %else %do;
      %etls_sendJobStatus(source_table = didm_stg.stg_promotion,dataset=MON_PRM.job_status);

      %di_util_lock(MON_PRM.job_status);
         data MON_PRM.job_status;
            set MON_PRM.job_status;
            where upcase(JOBNAME)=upcase("&etls_jobName")
            and STTIME ge "&etls_init_startTime"dt
            ;
            if JOBSTAT = 'Job Successful with Data Exceptions' then JOB_RC = 0.1;
         run;


      %di_etl_rcset(error=&syscc,code=job_rc);

      proc sql noprint;
         select max(JOB_RC) into :job_rc
         from MON_PRM.job_status
         where upcase(JOBNAME)=upcase("&etls_jobName")
           and STTIME ge "&etls_startTime"dt
         group by TABLE, JOBNAME;
      quit;

      %put job_rc=&job_rc;

      %if &job_rc = 0 %then
         %let jobstat = Job Successful;
      %else %if &job_rc = 0.1 %then %do;
         %let jobstat = Job Successful with Data Exceptions;
         %let job_rc = 4;
      %end;
      %else %if &job_rc le 4 %then
         %let jobstat = Job Ended with Warnings;
      %else %if &job_rc gt 4 %then
         %let jobstat = Job Ended with Errors;

      %put job_rc1=&job_rc;

      proc sql;
         update MON_PRM.job_status
         set job_rc = &job_rc
         where (upcase(JOBNAME)=upcase("&etls_jobName")
            and STTIME ge "&etls_startTime"dt
            and LIB= 'DI_DM')
            or  JOBSTAT = 'Job Successful with Data Exceptions';
      quit;

     %di_etl_rcset(error=&syserr,code=job_rc);

      proc sql;
         update MON_PRM.job_status
         set JOBSTAT = "&jobstat"
         where upcase(JOBNAME)=upcase("&etls_jobName")
           and STTIME ge "&etls_startTime"dt
           and LIB= 'DI_DM'
           or  JOBSTAT = 'Job Successful with Data Exceptions';
      quit;
     %di_util_unlock(MON_PRM.job_status);
     %di_etl_rcset(error=&syserr,code=job_rc);

      %di_util_lock(di_mon.job_status);

      proc append base = di_mon.job_status data = MON_PRM.job_status force;
      run;

      %di_util_unlock(di_mon.job_status);

      %di_etl_rcset(error=&syserr,code=job_rc);
   %end;

   proc datasets lib = MON_PRM nolist nowarn memtype = (data view);
      delete mpconn_arg_promo 
      job_status
      ;
   quit;

   proc sql noprint;
   select path into :data_lib_path
     from sashelp.vlibnam
    where libname = "MON_PRM"
      and level in (0,1);
   quit;

   %put data_lib_path =&data_lib_path;

   %let myrc =;
   %di_util_remove_directory(&data_lib_path
                            ,delete_directory=Y
                            ,_rc=myrc);
   %put RC=&myrc;

   libname MON_PRM clear;

%mend load_promotion_chk;

%load_promotion_chk;
/*---- End of User Written Code  ----*/

%let etls_endTime = %sysfunc(datetime(),datetime.);

